/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: configurator.cpp,v 1.10 2001/11/12 14:59:27 takayuki Exp $
 */


#include "staticapi.h"
#include <fstream>
#include "manager.h"
#include "domain.h"
#include "message.h"
#include "exception.h"
#include <iostream>
#include "garbage.h"

#ifdef WIN32
#include <windows.h>
#include <winnls.h>
#endif

using namespace std;

int main(int argc, char* argv[])
{
#ifdef WIN32
	Message::SelectCodePage(::GetUserDefaultLCID());
#endif

	cerr << "Configurator v7.0";
	if(ToplevelManagerComponent != NULL)
		cerr << " for [" << ToplevelManagerComponent->GetKernelName() << "]";
	cerr << endl;

	try
	{
		if(ToplevelManagerComponent == NULL)
			throw Exception(Message("No top-level manager found","ȥåץ٥Υޥ͡㤬ޤ"));

		if(!ToplevelManagerComponent->ParseOption(argc,argv))
			throw Exception(Message("Wrong parameter","ʥѥ᡼"));

		ToplevelManagerComponent->Body();

		Garbage::FinalCleanup();
		return EXIT_SUCCESS;
	}
	catch(Exception e)
	{
		cerr << string(Message("Fatal Error : [","̿Ūʥ顼 : [")) + static_cast<const char *>(e) + "]" << endl;
	}	

	Garbage::FinalCleanup();
	return EXIT_FAILURE;
}
