/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: domain.cpp,v 1.3 2001/11/12 14:59:27 takayuki Exp $
 */



/*
 * ITRON-MMU ץƥɥᥤ󥵥ݡȥ⥸塼
 *  )ܥ⥸塼ϸƤλ(2001/07)򸵤ˤƤꡤ
 *     ŪʤΤǤ뤿ᡤΥСǤϤʤʤǽ
 *
 * ɥᥤΥեޥåȤϼ̤
 *   domain <name> [ : shared|system|user ] { ŪAPI };
 * ɥᥤΥͥȤǤ⳰϶ͭˤʤ롥
 *
 * ɵ) ɥᥤΥͥȤ˻ͤ鳰줿
 */

#include "domain.h"
#include <algorithm>
#include "exception.h"
#include "manager.h"

using namespace std;

map<string, ProtectionDomain *> ProtectionDomain::Domain;

ProtectionDomain::ProtectionDomain(void)
{
	ParentDomain = NULL;
	Type = UNKNOWN;
	Name = "UNKNOWN";
};

ProtectionDomain::~ProtectionDomain(void)
{
	list<ProtectionDomain *> * container;
	list<ProtectionDomain *>::iterator scope;
	map<string, ProtectionDomain *>::iterator mapping;

		//Ƥȼڤ
	if(ParentDomain != NULL)
	{
		container = &ParentDomain->ChildDomain;
		scope = find(container->begin(), container->end(), this);
		if(scope != container->end())
			container->erase(scope);
		ParentDomain = NULL;
	}

		//ҤǤ
	scope = ChildDomain.begin();
	while(scope != ChildDomain.end())
	{
		(*scope)->ParentDomain = NULL;
		delete (*scope);
		scope ++;
	}
	ChildDomain.clear();

		//Ͽä
	mapping = Domain.find(Name);
	if(mapping != Domain.end())
		Domain.erase(mapping);
}

ProtectionDomain * ProtectionDomain::GetChildDomain(ProtectionDomain * prev)
{
	list<ProtectionDomain *>::iterator scope;

	if(prev != NULL)
	{
		scope = find(ChildDomain.begin(), ChildDomain.end(), prev);
	}else
		scope = ChildDomain.begin();

	if(scope != ChildDomain.end())
		scope ++;

	return scope == ChildDomain.end() ? NULL : (*scope);
}

void ProtectionDomain::Parse(Manager * mgr, Parser * p)
{
	Token token;

	mgr->CurrentDomain = this;
	p->GetToken(token,Token::IDENTIFIER,"domain");
	p->GetToken(token,Token::IDENTIFIER);
	Name = token;

	Type = USER;
	p->GetToken(token,Token::PUNCTUATOR);
	if(token.compare(":") == 0)
	{
		p->GetToken(token,Token::IDENTIFIER);
		if(token.compare("system") == 0)
			Type = SYSTEM;
		else if(token.compare("shared") == 0)
			Type = SHARED;
		else if(token.compare("user") == 0)
			Type = USER;
		else
			throw Exception();

		p->GetToken(token,Token::PUNCTUATOR);
	}

	if(token.compare("{") != 0)
		throw Exception();

	p->GetToken(token);
	while(token.compare("}") != 0)
	{
		if(token.Type != Token::IDENTIFIER)
			throw Exception();

		p->PutBack(token);
		if(token.compare("domain")==0)
		{
			ProtectionDomain * newdomain = CreateNewDomain(mgr);
			newdomain->ParentDomain = this;
			ChildDomain.push_back(newdomain);

			newdomain->Parse(mgr,p);
			mgr->CurrentDomain = this;
		}else
			mgr->API.Parse(mgr,p);
		p->GetToken(token);
	}
	p->GetToken(token,Token::PUNCTUATOR,";");
}
