/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: domain.h,v 1.3 2001/11/12 14:59:27 takayuki Exp $
 */


#ifndef __DOMAIN_H
#define __DOMAIN_H

//ITRONݸ ץƥɥᥤбѥ饹
//  ƤSharedǻҤSystemäƹͤƺäƤޤ

/*
 * ΥեϲŪʤΤǤꡤΥСǤϺǽ롥
 */

#ifdef _MSC_VER
#pragma warning(disable:4786)
#endif

#include "parser.h"
#include <list>
#include <map>
#include <string>

class ProtectionDomain : public ParserComponent
{
public:
	enum tagDomainType
	{
		UNKNOWN,
		USER,
		SYSTEM,
		SHARED
	};

protected:
	static std::map<std::string, ProtectionDomain *> Domain;
	
	enum tagDomainType Type;
	std::string Name;
	ProtectionDomain * ParentDomain;
	std::list<ProtectionDomain *> ChildDomain;

	virtual ProtectionDomain * CreateNewDomain(Manager *) =0;
public:
	ProtectionDomain(void);
	virtual ~ProtectionDomain(void);

	operator const enum tagDomainType (void) const;

	ProtectionDomain * GetParentDomain(void);
	ProtectionDomain * GetChildDomain(ProtectionDomain * = NULL);
	ProtectionDomain * FindDomain(std::string &);

	enum tagDomainType  GetType(void) { return Type; };
	const std::string & GetName(void) { return Name; };

	virtual void Parse(class Manager *, class Parser *);
};

inline ProtectionDomain::operator const enum ProtectionDomain::tagDomainType (void) const
{	return Type;	}

inline ProtectionDomain * ProtectionDomain::GetParentDomain(void)
{	return ParentDomain;	}

inline ProtectionDomain * ProtectionDomain::FindDomain(std::string & src)
{
	std::map<std::string, ProtectionDomain *>::iterator scope;
	
	if((scope = Domain.find(src)) == Domain.end())
		return NULL;
	return (*scope).second;
}

#endif