/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: exception.h,v 1.7 2001/11/12 14:59:27 takayuki Exp $
 */


#ifndef __EXCEPTION_H
#define __EXCEPTION_H

#include <string>
#include <iostream>

class Exception
{
protected:
	std::string Reason;
	static bool ThrowControl;

public:
	Exception(void) 
		{ Reason = ""; };
	Exception(const char * src)
		{ Reason = src; };
	Exception(const std::string & src)
		{ Reason = src; };
	Exception(const Exception & src)
		{ Reason = src.Reason; };
	
	std::string & GetReason(void) 
		{ return Reason; };
	operator const char * (void)
		{ return this->GetReason().c_str(); };
	operator const std::string & (void)
		{ return this->GetReason(); }

	static bool GetThrowControl(void);
	static bool SetThrowControl(bool);
	static void Throw(const char *);
	static void Throw(const std::string &);
	static void Throw(const Exception &);
};

inline std::ostream & operator << (std::ostream & dest, Exception & e)
{	return (dest << static_cast<const char *>(e));	}

inline bool Exception::GetThrowControl(void)
{	return ThrowControl;	}

inline bool Exception::SetThrowControl(bool mode)
{
	bool old = ThrowControl;
	ThrowControl = mode;
	return old;
}

inline void Exception::Throw(const char * src)
{
	if(ThrowControl)
		throw Exception(src);
}

inline void Exception::Throw(const Exception & src)
{
	if(ThrowControl)
		throw src;
}

inline void Exception::Throw(const std::string & src)
{
	if(ThrowControl)
		throw Exception(src);
}

#endif
