/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: toppers.h,v 1.5 2001/11/13 11:58:17 takayuki Exp $
 */

/*
 * ΥեϲŪʤΤǤꡤΥСǤϺǽ
 *  (ä˥ץƥɥᥤ˴ؤʬ)
 */

#ifndef __TOPPERS_H
#define __TOPPERS_H

#ifdef _MSC_VER
#pragma warning(disable:4786)
#endif

#include <string>
#include <vector>
#include <map>
#include <set>

#include "../manager.h"
#include "../domain.h"
#include "../staticapi.h"
#include "../serializer.h"
#include "../garbage.h"
#include "../id.h"
#include "../value.h"

	//ǤФե̾
#define ORTIFILE "toppers_info.odl"
#define CFGFILE "kernel_cfg.c"
#define DOMAINCFGPREFIX "_cfg.c"
#define SHAREDOMFILE "shared_cfg.c"
#define HEADER "kernel_id.h"
#define LDSCRIPT "ld.script"
#define CHECKER "kernel_chk.c"

	//ޥ
#define DECLARE_API(x) class API_##x : public StaticAPI { public: class BaseObject * Parent; const char * GetAPIName(void) { return #x; }; void Body(Manager *, Array *); } x; friend class x;
#define DECLARE_PAPI(x) class API_##x : public StaticAPI { const char * GetAPIName(void) { return #x; }; void Body(Manager *, Array *); } x; friend class x;
#define INIT_API(x) x##.Parent = this;
#define DECLARE_OBJECT(x,y) class x : public BaseObject { public: DECLARE_API(y); x(void) { INIT_API(y); }; };

enum tagOption
{
	ORTISUPPORT,
	DOMAINSUPPORT,
	VERBOSE,
	FORCEDOMAINSUPPORT,
	CHECKERFILE
};

class BaseObject
{
public:
	std::map<std::string, int> ObjectID;
	ID Identifier;
	Array Parameter;

	void InitializeParameter(int, int);
	bool LoadParameter(int, Array *, const char *,const char ** = NULL);
	void SetParameter(int, int, Value *);
	Value * GetParameter(int, int);

	int AssignNewObjectID(Manager *, int);
	int AssignObjectID(Manager *,Value *,int);
	int GetObjectID(Value *);

	void Serialization(Manager *, MultiStream &, const char *, const char *, const char * = NULL);
	void CreateBuffer(Manager *, MultiStream &, const char *, int, int, const char *, const char *);
};


	//֥
class Task : public BaseObject
{
public:
	enum tagPart
	{	TYPE=0, EXINF, TASK, PRIORITY, STACKSIZE, STACK, TEXTYPE, TEXFUNC};

	DECLARE_API(CRE_TSK);
	DECLARE_API(DEF_TEX);
	Task(void) 
	{ 
		INIT_API(CRE_TSK); 
		INIT_API(DEF_TEX);
	};
};

	//ҤȤĤAPIʤ̵ͭݤɤ
DECLARE_OBJECT(Semaphore, CRE_SEM);
DECLARE_OBJECT(EventFlag, CRE_FLG);
DECLARE_OBJECT(DataQueue, CRE_DTQ);
DECLARE_OBJECT(Mailbox,   CRE_MBX);
DECLARE_OBJECT(CyclicHandler, CRE_CYC);

class FixedsizeMemoryPool : public BaseObject
{
public:
	FixedsizeMemoryPool(void) { INIT_API(CRE_MPF); };

	DECLARE_API(CRE_MPF);
	void Serialization(Manager *, MultiStream &, const char *, const char *, const char * = NULL);
};

	//ߥϥɥ
class InterruptHandler : public BaseObject
{
public:
	InterruptHandler(void) { INIT_API(DEF_INH); };

	DECLARE_API(DEF_INH);

	void Serialization(Manager *, MultiStream &);
};

	//㳰ϥɥ
class ExceptionHandler : public BaseObject
{
public:
	ExceptionHandler(void) { INIT_API(DEF_EXC); };

	DECLARE_API(DEF_EXC);

	void Serialization(Manager *, MultiStream &);
};

	//ϥɥ饪֥
class InitializeHandler : public BaseObject
{
protected:
	std::list<std::string> HandlerList;

public:
	InitializeHandler(void) { INIT_API(ATT_INI); };
	
	DECLARE_API(ATT_INI);

	void Serialization(Manager *, MultiStream &);
};
	

	//JSPǤݸɥᥤ򥵥ݡȤƤʤΤǡ
	//ƥñ (ץǳ뤱ɸ̤ʤ)
class ToppersDomain : public ProtectionDomain, public Serializer, public Garbage
{
protected:
	ProtectionDomain * CreateNewDomain(Manager *);
public:
	typedef std::set<int> set_int;
	std::map<BaseObject *, set_int> Object;

	void Parse(class Manager *, Parser *);
	bool Validation(Manager *);
	void Serialization(Manager *, MultiStream &);
};

/*
 * TOPPERS/JSPͥ륳ե졼 
 */
class ToppersManager : public Manager, public Serializer
{
protected:
	std::string filename;

public:
	std::list<std::string> IncludeFile;
	std::list<std::string> Initializer;
	
	Task task;
	Semaphore semaphore;
	EventFlag eventflag;
	DataQueue dataqueue;
	Mailbox mailbox;
	FixedsizeMemoryPool fmempool;
	CyclicHandler cyclic;
	InterruptHandler inthdr;
	ExceptionHandler exchdr;
	InitializeHandler inihdr;

	ToppersManager(void);
	~ToppersManager(void) {};

	const char * GetKernelName(void) { return "TOPPERS/JSP kernel ver.1.1 (patchlevel=1)"; };
	bool ParseOption(int, char *[]);
	void Body(void);
	void Serialization(Manager *, MultiStream &);

	DECLARE_PAPI(INCLUDE);
};

#endif
