/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: manager.cpp,v 1.10 2001/11/12 14:59:27 takayuki Exp $
 */


#include "manager.h"
#include <iostream>
#include <fstream>
#include <algorithm>
#include "multistream.h"
#include "serializer.h"

using namespace std;

Manager * ToplevelManagerComponent = NULL;

Manager::Manager(void)
{
	Option.clear();
	CurrentDomain = NULL;

	if(::ToplevelManagerComponent == NULL)
		::ToplevelManagerComponent = this;
	else
		throw Exception();
}

Manager::~Manager(void)
{}

void Manager::ParseBody(ParserComponent * top, const char * filename)
{
	Parser parser;
	fstream file;
	istream * in;

	if(filename != NULL && *filename != '\x0')
	{
		file.open(filename,ios::in);
		if(!file.is_open())
			throw Exception("եΥץ˼Ԥ");
		in = static_cast<istream *>(&file);
	}else
		in = &cin;

	parser.SetStream(in);
	top->Parse(this, &parser);

	if(filename != NULL)
		file.close();
}

void Manager::SerializeBody(void)
{
	unsigned int i;
	list<Serializer *> serializer;
	list<Serializer *>::iterator scope;
	MultiStream output;

		//Validation
	scope = SerializeUnit.begin();
	while(scope != SerializeUnit.end())
	{
		serializer.push_back(*scope);
		scope ++;
	}

	do{
		i = serializer.size();
		scope = serializer.begin();
		while(scope != serializer.end())
		{
			if((*scope)->Validation(this))
				scope = serializer.erase(scope);
			else
				scope ++;
		}
	}while(!serializer.empty() && (serializer.size() < i));

		//Serialization
	scope = SerializeUnit.begin();
	while(scope != SerializeUnit.end())
	{
		(*scope)->Serialization(this,output);
		scope ++;
	}
}
