/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: manager.h,v 1.7 2001/11/12 14:59:27 takayuki Exp $
 */


#ifndef __MANAGER_H
#define __MANAGER_H

#include "staticapi.h"
#include "domain.h"
#include <set>

class Manager
{
protected:
	void ParseBody(ParserComponent *,const char * = NULL);
	void SerializeBody(void);

public:
	std::set<int> Option;
	std::list<class Serializer *> SerializeUnit;
	StaticAPIContainer API;
	ProtectionDomain * CurrentDomain;

	Manager(void);
	virtual ~Manager(void);

	void SetOption(int);
	const bool operator [](int) const;

	virtual const char * GetKernelName(void) = 0;
	virtual bool ParseOption(int, char *[]) =0;
	virtual void Body(void) =0;

	Manager & operator << (Serializer *);
	Manager & operator << (StaticAPI *);
};

inline void Manager::SetOption(int num)
{	Option.insert(num);	}

inline const bool Manager::operator [](int pos) const
{	return Option.find(pos) != Option.end();	}

inline Manager & Manager::operator << (Serializer * ser)
{
	if(ser != NULL)
		SerializeUnit.push_back(ser);
	return *this;
}

inline Manager & Manager::operator << (StaticAPI * api)
{
	if(api != NULL)
		API.Add(api);
	return *this;
}

extern class Manager * ToplevelManagerComponent;

#endif