/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: multistream.cpp,v 1.7 2001/11/12 14:59:27 takayuki Exp $
 */


#include "multistream.h"
#include "exception.h"
#include "message.h"

#ifdef _MSC_VER
#pragma warning(disable:4786)
#endif

using namespace std;

Message MSG_COULDNOTCREATE("Failed to create the file","ե˼Ԥޤ");



MultiStream::MultiStream(void)
{
	Stream.clear();
}

MultiStream::~MultiStream(void)
{
	CloseAllStreams();
}

bool MultiStream::Add(const string & name)
{
	if(name.empty())
		return false;

	if(Stream.find(name) != Stream.end())
		return false;

	fstream * work = new fstream(name.c_str(),ios::out|ios::trunc);

	if(!work->is_open())
	{
		delete work;
		return false;
	}

	Stream[name] = work;
	LastReferedStream = work;

	return true;
}

fstream * MultiStream::operator [](const string & name)
{
	map<string, fstream *>::iterator scope;

	scope = Stream.find(name);
	if(scope == Stream.end())
	{
		if(!Add(name))
			throw Exception(string(MSG_COULDNOTCREATE) + " [" + name + "]");
		return Stream[name];
	}

	LastReferedStream = (*scope).second;
	return LastReferedStream;
}

bool MultiStream::Close(const string & src)
{
	map<string, fstream *>::iterator scope;

	scope = Stream.find(src);
	if(scope == Stream.end())
		return false;

	if((*scope).second != 0l)
	{
		(*scope).second->close();
		delete (*scope).second;
	}

	Stream.erase(scope);
	LastReferedStream = NULL;

	return true;
}

bool MultiStream::CloseAllStreams(void)
{
	map<string,fstream *>::iterator scope;

	scope = Stream.begin();
	while(scope != Stream.end())
	{
		if((*scope).second != 0l)
		{
			(*scope).second->close();
			delete (*scope).second;
		}

		scope ++;
	}

	Stream.clear();

	LastReferedStream = NULL;
	return true;
}

