/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: multistream.h,v 1.5 2001/11/12 14:59:27 takayuki Exp $
 */


#ifndef __MULTISTREAM_H
#define __MULTISTREAM_H

#ifdef _MSC_VER
#pragma warning(disable:4786)
#endif

#include <map>
#include <string>
#include <fstream>

class MultiStream
{
protected:
	std::map<std::string, std::fstream *> Stream;
	std::fstream * LastReferedStream;

public:
	MultiStream(void);
	~MultiStream(void);

	operator std::fstream * (void);

	bool Add(const char *);
	bool Add(const std::string &);

	bool Close(const char *);
	bool Close(const std::string &);

	bool CloseAllStreams(void);

	std::fstream * operator [](const char *);
	std::fstream * operator [](const std::string&);

	std::fstream & operator *(void) const;
};

inline bool MultiStream::Add(const char * src)
{	return Add(std::string(src));	}

inline bool MultiStream::Close(const char * src)
{	return Close(std::string(src));	}

inline std::fstream * MultiStream::operator [](const char * name)
{	return this->operator [] (std::string(name));	}

inline MultiStream::operator std::fstream *(void)
{	return LastReferedStream;	}

inline std::fstream & MultiStream::operator *(void) const
{	return *LastReferedStream;	}

#endif