/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: staticapi.cpp,v 1.6 2001/11/12 14:59:27 takayuki Exp $
 */



#include "staticapi.h"
#include "exception.h"
#include "message.h"

using namespace std;

StaticAPIContainer::StaticAPIContainer(void)
{}

StaticAPIContainer::~StaticAPIContainer(void)
{}

bool StaticAPIContainer::Add(StaticAPI * api)
{
	string work;

	if(api == NULL || api->GetAPIName() == NULL)
		return false;

	work = api->GetAPIName();
	if(API.find(work) != API.end())
		return false;

	API[work] = api;
	return true;
}

void StaticAPIContainer::ParseParameterBlock(Manager * mgr, Parser * p, Array * parameter, Token delimiter)
{
	Token token;
	Token param;
	int nest;
	bool skip;

	skip = true;
	nest = 0;
	for(p->GetToken(token,true); token != delimiter; p->GetToken(token,true))
	{
		if(token == Token::PUNCTUATOR)
		{
			if(token.compare(",") == 0)
			{
				if(nest > 0)
				{
					param += token;
					continue;
				}

				if(!skip)
				{
					if(param == Token::INTEGER)
						parameter->push_back(new Integer(param.Value));
					else
						parameter->push_back(new String(param.Trim()));
				}
				param.erase();
				continue;
			}

			skip = false;

			if(token.compare("(") == 0)
			{
				param.Type = Token::SPECIAL;
				nest ++, param += token;
				continue;
			}

			if(token.compare(")") == 0)
			{
				nest --, param += token;
				continue;
			}

			if(token.compare("{") == 0)
			{
				Array * child = new Array;
				parameter->push_back(child);
				ParseParameterBlock(mgr,p,child,Token(Token::PUNCTUATOR,"}"));
				skip = true;
				continue;
			}
		}

		if(skip == true && token != Token::SPACE)
			skip = false;

		if(param.empty())
		{
			if(token != Token::SPACE)
				param = token;
		}else
		{
			param.Type = Token::SPECIAL;
			if(token == Token::SPACE)
				param += ' ';
			else
				param += token;
		}
	}

	if(!skip)
	{
		if(param == Token::INTEGER)
			parameter->push_back(new Integer(param.Value));
		else
			parameter->push_back(new String(param.Trim()));
	}
}

void StaticAPIContainer::Parse(Manager * mgr, Parser * p)
{
	map<string,StaticAPI *>::iterator scope;
	Token token;
	string api;
	Array parameter;

	p->GetToken(token,Token::IDENTIFIER);
	api = token;

	if((scope = API.find(api)) == API.end())
		throw Exception(string(Message("Unknown Static API Name [","API̾ [")) + api + "]");

	p->GetToken(token,Token::PUNCTUATOR,"(");
	ParseParameterBlock(mgr, p, &parameter, Token(Token::PUNCTUATOR,")"));

	p->GetToken(token, Token::PUNCTUATOR,";");

	if((*scope).second->Enabled == true)
		(*scope).second->Body(mgr, &parameter);
}
	
