/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: staticapi.h,v 1.8 2001/11/12 14:59:27 takayuki Exp $
 */


//------------------------------------------------------------
// StaticAPI - class definition
//

#ifndef __STATICAPI_H
#define __STATICAPI_H

#ifdef _MSC_VER
#pragma warning(disable:4786)
#endif

#include "value.h"
#include "exception.h"
#include "parser.h"
#include <map>
#include <string>

class StaticAPI
{
public:
	bool Enabled;

	StaticAPI(void) { Enabled = true; };
	virtual ~StaticAPI(void) {};

	virtual const char * GetAPIName(void) =0;
	virtual void Body(class Manager *, Array *) =0;
};

class StaticAPIContainer : public ParserComponent
{
protected:
	std::map<std::string, StaticAPI *> API;

	void ParseParameterBlock(class Manager *, Parser *, Array *, Token);

public:
	StaticAPIContainer(void);
	virtual ~StaticAPIContainer(void);

	virtual void Parse(class Manager *, Parser *);

	bool Add(StaticAPI *);
};

#endif

//---
// Degined and Programmed by S.D.F. in Oct,2000
