/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: value.cpp,v 1.4 2001/11/14 12:50:10 takayuki Exp $
 */



#include "value.h"

#include <string.h>

using namespace std;

Array::Array(const Array & src)
{
	(*this) = src;
}

Array::~Array(void)
{	clear();	}


Array & Array::operator =(const Array & src)
{
	unsigned int i;

	resize(src.size(),NULL);
	for(i=0;i<src.size();i++)
	{
		if((*this)[i] != NULL)
			(*this)[i] = src[i]->Duplicate();
		else
			(*this)[i] = NULL;
	}

	return *this;
}


void Array::clear()
{
	vector<Value *>::iterator scope;

	scope = begin();
	while(scope != end())
	{
		if((*scope) != NULL)
			delete * scope;
		scope ++;
	}

	vector<Value *>::clear();
}

void Array::Serialize(ostream & out) const
{
	const_iterator scope;

	out << "{";

	scope = begin();
	while(scope != end())
	{
		if(scope != begin())
			out << ",";
		if( *scope != NULL )
			(*scope)->Serialize(out);
		else
			out << "<null>";
		scope ++;
	}

	out << "}";
}
