/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: cpu_config.h,v 1.8 2001/11/09 12:08:54 honda Exp $
 */

/*
 *	ץå¸⥸塼ARM7TDMIѡ
 */
#ifndef _CPU_CONFIG_H_
#define _CPU_CONFIG_H_

/*
 *  ͥ̾Υ͡
 */
#ifndef OMIT_RENAME

#define activate_r      _kernel_activate_r
#define ret_int         _kernel_ret_int
#define ret_exc         _kernel_ret_exc

#ifdef LABEL_ASM

#define _activate_r     __kernel_activate_r
#define _ret_int        __kernel_ret_int
#define _ret_exc        __kernel_ret_exc

#endif /* LABEL_ASM */
#endif /* OMIT_RENAME */

/*
 *  ץåü̿Υ饤ؿ
 */
#ifndef _MACRO_ONLY
#include "cpu_insn.h"
#endif /* _MACRO_ONLY */

/*
 *  TCB Ϣ
 *
 *  cpu_context.h 쥬ȤȤΰ¸δطǡ
 *  cpu_context.h ˤʤ
 */

/*
 *  TCB ΥեɤΥӥå
 */
#define	TBIT_TCB_TSTAT		8	/* tstat եɤΥӥå */
#define	TBIT_TCB_PRIORITY	8	/* priority եɤΥӥå */

#ifndef _MACRO_ONLY
/*
 *  ƥȥ֥å
 */
typedef struct task_context_block {
	VP	sp;		/* åݥ */
	FP	pc;		/* ץ५ */
} CTXB;

/*
 * ߤΥͥȲΥ
 */
extern UW interrupt_count;


/*
 *  ƥֻ
 */
Inline UB
current_mode()
{
    return(current_sr() & CPSR_MODE_MASK);
}

Inline BOOL
sense_context()
{
	return(interrupt_count > 0);
}

Inline BOOL
sense_lock()
{
	return(current_sr() & CPSR_IRQ_BIT);
}

#define t_sense_lock	sense_lock
#define i_sense_lock	sense_lock


/*
 *  CPUåȤβ
 *
 */

#define t_lock_cpu      lock_cpu
#define i_lock_cpu      lock_cpu
#define t_unlock_cpu    unlock_cpu
#define i_unlock_cpu    unlock_cpu


Inline void
lock_cpu()
{
	disint();
}

Inline void
unlock_cpu()
{
	enaint();
}


/*
 *  ǥѥå
 */

/*
 *  ǹ̥ͥؤΥǥѥåcpu_support.S
 *
 *  dispatch ϡƥȤƤӽФ줿ӥ
 *  ǡCPUå֤ǸƤӽФʤФʤʤ
 */
extern void	dispatch(void);


/*
 *  ߤΥƥȤΤƤƥǥѥåcpu_support.S
 *
 *  exit_and_dispatch ϡCPUå֤ǸƤӽФʤФʤʤ
 */
extern void	exit_and_dispatch(void);


/*
 * 㳰٥˽񤭹ޤ줿̿᤬Ȥ륢ɥ쥹
 */
extern UW *arm_vector_add[8];


/*
 * 㳰˱ϥɥεư
 */
extern UW arm_handler_add[8];


/*
 *  CPU㳰ϥɥ
 */
extern void define_exc(EXCNO excno, FP exchdr);


Inline void
arm_install_handler(EXCNO excno, FP exchdr)
{
    *arm_vector_add[excno] = (UW)exchdr;
}


/*
 *  CPU㳰ϥɥν
 */


/*
 *  CPU㳰ϥɥνޥ
 *
 */
#define __EXCHDR_ENTRY(exchdr, stacktop)    \
extern void exchdr##_entry(VP sp);          \
asm(".text                             \n"  \
#exchdr "_entry:                       \n"  \
"       ldr   sp,.int_stack_"#exchdr"  \n"  /* åڤؤ        */\
"       sub   lr,lr,#4                 \n"  /* undefǤ⤳Ǥ?    */\
"       stmfd sp!, {r0 - r2,lr}        \n"  /* Ūint_stack   */ \
"       mrs   r0, spsr                 \n"  /* SYS⡼ɤڤؤ뤿 */ \
"       mov   r1, sp                   \n"  /* ¸                  */ \
"       mov   r2,#0xdf                 \n"  /* CPSRν񤭴            */ \
"       msr   cpsr,r2                  \n" \
"       ldr   r2,[r1,#0x0C]            \n"     /* load  PC            */\
"       stmfd sp!,{r2}                 \n"     /* Store PC            */\
"       stmfd sp!,{r3,ip,lr}           \n"     /* Store r3,ip,lr      */\
"       ldmfd r1!,{r2,ip,lr}	       \n"     /* load  r0,r1,r2      */\
"       stmfd sp!,{r0,r2,ip,lr}        \n"     /* SPSR,Store r0,r1,r2 */\
"       ldr  r2, .interrupt_count_"#exchdr"\n" /* ¿ųߤȽ  */\
"       ldr  r3, [r2]                  \n" \
"       add  r0,r3,#1                  \n" \
"       str  r0, [r2]                  \n" \
"       mov  r0,sp                     \n" /* 㳰ϥɥؤΰ */\
"       cmp  r3, #0x00                 \n" \
"       ldreq   sp,stack_"#exchdr"     \n" /* åѹ       */\
"       stmeqfd sp!,{r0}               \n" /* å¸ */\
"       mov   r2,#0x1f                 \n" /* ߵ         */\
"       msr   cpsr,r2                  \n" \
"		bl    "#exchdr"                \n" /* ϥɥƤӽФ     */\
"       mov   r2,#0xdf                 \n" /* ߶ػ         */\
"       msr   cpsr,r2                  \n" \
"       ldr   r2,.interrupt_count_"#exchdr" \n"/* ߲   */\
"       ldr   r1, [r2]                 \n"     /* ǥ     */\
"       sub   r3,r1,#1                 \n"\
"       str   r3, [r2]                 \n"\
"       cmp   r3,#0x00                 \n" /* ߥͥȿ?    */\
"       bne   return_to_task_"#exchdr" \n" \
"       ldmfd sp!,{r0}                 \n" /* å */\
"       mov   sp, r0                   \n"\
"		ldr   r1, reqflg_"#exchdr"     \n" /* Check reqflg         */\
"		ldr   r0,[r1]                  \n"\
"		cmp   r0,#0                    \n"\
"		beq   return_to_task_"#exchdr" \n"\
"       mov   r0,#0                    \n"\
"		str   r0,[r1]                  \n" /* Clear reqflg   */\
" 		b     _kernel_ret_exc          \n" /* ret_int      */\
"return_to_task_"#exchdr":             \n" \
"       ldmfd sp!,{r1}                 \n" /* CPSR */\
"       msr   cpsr, r1                 \n" /* ߵ   */\
"       ldmfd sp!,{r0-r3,ip,lr,pc}     \n"\
"       .align 4                       \n"\
".int_stack_"#exchdr":                 \n"\
"        .long int_stack + 6 * 4       \n"\
"reqflg_"#exchdr":                     \n"\
"		.long     _kernel_reqflg       \n"\
"stack_"#exchdr":                      \n"\
"        .long   " #stacktop "         \n"\
".interrupt_count_"#exchdr":           \n"\
"        .long   interrupt_count       \n")


#define _EXCHDR_ENTRY(exchdr, stacktop)    __EXCHDR_ENTRY(exchdr, stacktop)

#define EXCHDR_ENTRY(exchdr)    _EXCHDR_ENTRY(exchdr, STACKTOP)

#define EXC_ENTRY(exchdr) exchdr##_entry


/*
 *  CPU㳰ȯΥƥ֤λ
 */

/*
 *  CPU㳰ȯΥǥѥå
 *  NotYet! 
 */
Inline BOOL
exc_sense_context(VP p_excinf)
{
	return(interrupt_count > 1);    
}

/*
 *  CPU㳰ȯCPUå֤λ
 *  NotYet! 
 */
Inline BOOL
exc_sense_lock(VP p_excinf)
{
    return((*((UW *)p_excinf) & CPSR_IRQ_BIT) == CPSR_IRQ_BIT );
}


/*
 *  ٥̾뤿Υޥ
 */
#define	_LABEL_ALIAS(new_label, defined_label) \
	asm(".globl " #new_label "\n" #new_label " = " #defined_label);
#define LABEL_ALIAS(x, y) _LABEL_ALIAS(x, y)


/*
 *  ץå¸ν
 */
extern void	cpu_initialize(void);


/*
 *  ץå¸νλ
 */
extern void	cpu_terminate(void);


/*
 * CPU/ߥϥɥνǰŪ˻Ѥ륹å
 */
#define INT_STACK_SIZE 6
extern UW int_stack[INT_STACK_SIZE];


#endif /* _MACRO_ONLY */
#endif /* _CPU_CONFIG_H_ */
