/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: hw_serial.h,v 1.3 2001/11/08 21:28:19 honda Exp $
 */

#ifndef _HW_SERIAL_H_
#define _HW_SERIAL_H_

/*
 *  åȰ¸ꥢI/O⥸塼Evaluator-7Tѡ
 *  SCI0
 */

#include "evaluator7t.h"
#include "sys_defs.h"
#include "sys_config.h"


/*
 *  ꥢI/OγߥϥɥΥ٥ֹ
 */
#define INHNO_SERIAL_IN	 IRQ_NUMBER_UART0_RX
#define INHNO_SERIAL_OUT IRQ_NUMBER_UART0_TX


/*
 *  ꥢݡȤΥϡɥ¸
 *  Not yet! m68kΤ褦˥ȥ쥸¤Τˤ롣
 */
typedef struct hardware_serial_port_descripter {
    INT	  *initflag;	   /* ѥե饰ؤΥݥ   */
    BOOL  sendflag;        /* ߥ֥͡ե饰 */
} HWPORT;



/*
 * SCI1γߥ٥
 * Ʊꤹ롣
 */
#define SCI0INTLVL_TX   5
#define SCI0INTLVL_RX   6


/*
 *  ٥ݡȾ֥åν
 */

#define NUM_PORT	1	/* ݡȤ륷ꥢݡȤο */
static INT	initflag[1] = { 0 } ;	/* ѥե饰 */
#define HWPORT1	{ &initflag[0],  0 }


/*
 *  ꥢI/OݡȤν
 */
Inline BOOL
hw_port_initialize(HWPORT *p)
{
    UART0.UCON = 0;                /* Disable Interrupt */
    UART0.ULCON = ULCON_WL_8BIT;   /* 8Data, 1Stop, No Parity */
    UART0.UBRDIV = UBRDIV_19200;    /* 9600bps */


    /*
     * ߴϢ
     */
    UART0.UCON = UCON_RxM_INT;    /* Enable Interrupt */
    /* Clear Rx Tx Pending bit */    
    *INTPND = (IRQ_BIT_UART0_RX | IRQ_BIT_UART0_TX);



    /* Set Interrupt priority (SW) */
    
    /* Set Interrupt priority (HW) */
    
//    *(INTPRI0 + SCI0INTLVL_TX / 4) =
//        IRQ_NUMBER_UART0_TX << (SCI0INTLVL_TX % 4);
//    *(INTPRI0 + SCI0INTLVL_RX / 4) =
//        IRQ_NUMBER_UART0_RX << (SCI0INTLVL_RX % 4);

    
    /* Enable Interrupt Rx */
    *INTMSK &= ~((1 << INT_GLOBAL) | IRQ_BIT_UART0_RX |IRQ_BIT_UART0_TX); 
    
    *(p->initflag) = 1;			/* ե饰 */
    return(FALSE);
}


/*
 *  ꥢI/OݡȤνλ
 */
Inline void
hw_port_terminate(HWPORT *p)
{
	*(p->initflag) = -1;		/* ե饰           */
    UART0.UCON = 0;             /* Disable Interrupt */    
    /* Clear Rx Tx Pending bit */    
    *INTPND = (IRQ_BIT_UART0_RX | IRQ_BIT_UART0_TX);
}


/*
 *  ꥢݡȳߥӥ롼ȡ
 */
extern void	serial_handler_in(int portid);
extern void	serial_handler_out(int portid);


/*
 *  ꥢI/OݡȤγߥϥɥ
 */
Inline void
hw_serial_handler_in()
{
    if (initflag[0] > 0)
        serial_handler_in(1);        
    else
        *INTPND = IRQ_BIT_UART0_RX;
}


Inline void
hw_serial_handler_out()
{
    if (initflag[0] > 0)
        serial_handler_out(1);
    else
        *INTPND = IRQ_BIT_UART0_TX;
}


/*
 *  ʸ
 */
Inline BOOL
hw_port_getready(HWPORT *p)
{
	return((UART0.USTAT & USTAT_RDR)!=0);
}


/*
 *  ʸǤ뤫
 */
Inline BOOL
hw_port_putready(HWPORT *p)
{
	return((UART0.USTAT & USTAT_TBE)!=0);
}


/*
 *  ʸμФ
 */
Inline byte
hw_port_getchar(HWPORT *p)
{
    return(UART0.URXBUF);         
}


/*
 *  ʸν񤭹
 */
Inline void
hw_port_putchar(HWPORT *p, byte c)
{
    UART0.UTXBUF=c;
}


/*
 *  ؿ
 */
Inline void
hw_port_sendstart(HWPORT *p)
{
    
    if (!(p->sendflag)) {
        UART0.UCON = (UART0.UCON & ~UCON_TxM_MASK) | UCON_TxM_INT;
/*        *INTPND = IRQ_BIT_UART0_TX;        */
        /* Enable Interrupt */        
        p->sendflag = 1;
    }
}


Inline void
hw_port_sendstop(HWPORT *p)
{
	if (p->sendflag) {
//        UART0.UCON = (UART0.UCON & ~UCON_TxM_MASK) | UCON_TxM_DIS;
        UART0.UCON = (UART0.UCON & ~UCON_TxM_MASK) | UCON_TxM_GDMA0;
        *INTPND = IRQ_BIT_UART0_TX;                
       /* Disable Interrupt */
        p->sendflag = 0;
	}
}

#endif /* _HW_SERIAL_H_ */





















