/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: hw_timer.h,v 1.3 2001/11/08 21:28:19 honda Exp $
 */

#ifndef _HW_TIMER_H_
#define _HW_TIMER_H_

/*
 *  CPU¸ޥ⥸塼Evaluator-7Tѡ
 *  TMU0
 */
#include "evaluator7t.h"
#include "sys_defs.h"
#include "cpu_config.h"
#include "sys_config.h"


/*
 *  ޳ߤγֹ
 */
#define	INHNO_TIMER	IRQ_NUMBER_TMU0


/*
 *  ͤɽη
 */
typedef UW	CLOCK;


/*
 *  ޡγߥ٥
 */
#define TINTLVL0        4


/*
 *  ޡ
 */
#define TO_CLOCK(nume, deno)	(TIMER_CLOCK * (nume) / (deno))


/*
 *  ǤΥ޼ñ̤ɽ
 */
#define MAX_CLOCK	((CLOCK) 0xffffffff)


/*
 *  ǽɾѥƥФݤν֤θѤ͡ñ̤ɽ
 */
#define GET_TOLERANCE	100


/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ롥
 */
Inline void
hw_timer_initialize()
{
	CLOCK	c = TO_CLOCK(TIC_NUME, TIC_DENO);
        
	/*
	 *  ޴Ϣ
	 */
    *TMOD = 0;                       /*  */
    assert(c <= MAX_CLOCK);		     /* ޾ͤΥå */

    *INTPND = IRQ_BIT_TMU0;          /* ߤΥꥢ  */
    *TCNT0       = 0;
    *TDATA0      = c;                /* ͤ򥻥å */
    *TMOD       |= TM_TE0;           /* ȥ   */

    
    /*
	 *  ߴϢ
	 */
    /* ߥ٥(SF) */
    
    /* ߥ٥(HW) */    
//    *(INTPRI0 + TINTLVL0 / 4) =   IRQ_NUMBER_TMU0 << (TINTLVL0 % 4);

    *INTPND  = IRQ_BIT_TMU0;                 /* ׵򥯥ꥢ   */
    *INTMSK &= ~((1 << INT_GLOBAL) | IRQ_BIT_TMU0 ); /* ߵ */    
}


/*
 *  ޳׵Υꥢ
 */
Inline void
hw_timer_int_clear()
{
  *INTPND  = IRQ_BIT_TMU0;                 /* ڥǥ󥰥ӥåȤ򥯥ꥢ */
}


/*
 *  ޤ߽
 */
Inline void
hw_timer_terminate()
{
    *TMOD   |= ~TM_TE0;                      /* ޤ */
    *INTMSK |= IRQ_BIT_TMU0;                 /* Ե*/    
    *INTPND  = IRQ_BIT_TMU0;                 /* ڥǥ󥰥ӥåȤ򥯥ꥢ */
}


/*
 *  ޤθͤɤߤ
 *
 *  ߶ػ߶ǸƤӽФȡ
 */
Inline CLOCK
hw_timer_get_current(void)
{
	return(TO_CLOCK(TIC_NUME, TIC_DENO) - *TCNT0);
}


Inline BOOL
hw_timer_fetch_interrupt(void)
{
	return(*INTPND & IRQ_BIT_TMU0);
}

#endif /* _HW_TIMER_H_ */



