/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: cpu_config.h,v 1.1 2001/11/12 13:38:30 abe Exp $
 */

/*
 *  ץå¸⥸塼H8ѡ
 */

#ifndef _CPU_CONFIG_H_
#define _CPU_CONFIG_H_

/*
 *  ͥ̾Υ͡
 */
#ifndef OMIT_RENAME

#define activate_r		_kernel_activate_r
#define ret_int			_kernel_ret_int
#define ret_exc			_kernel_ret_exc
#define task_intmask		_kernel_task_intmask
#define int_intmask		_kernel_int_intmask

#ifdef LABEL_ASM

#define _activate_r		__kernel_activate_r
#define _ret_int		__kernel_ret_int
#define _ret_exc		__kernel_ret_exc
#define _task_intmask		__kernel_task_intmask
#define _int_intmask		__kernel_int_intmask

#endif /* LABEL_ASM */
#endif /* OMIT_RENAME */

/*
 *  ץåü̿Υ饤ؿ
 */

#ifndef _MACRO_ONLY
#include "cpu_insn.h"
#endif /* _MACRO_ONLY */

#ifndef _MACRO_ONLY

/*
 *  ƥȥ֥å
 */

typedef struct task_context_block {
	VP	sp;		/* åݥ */
	FP	pc;		/* ץ५ */
} CTXB;

/*
 *  ߥޥ饤֥
 */

/*
 *  ߤγߥޥɽФ
 */

Inline UB
current_intmask()
{
	return(current_ccr() & H8INT_MASK_ALL);
}

/*
 *  ߥޥ
 */

Inline void
set_intmask(UB intmask)
{
	set_ccr((current_ccr() & ~H8INT_MASK_ALL) | intmask);
}

/*
 *  ߥͥȥ
 */

extern UW	intnest;

/*
 *  ƥȻ
 *
 *  ߥͥȥ󥿤ɤ߽Фľ˳ߤȯƤ⡢ä
 *  ˤϥƥȤ⸵äƤ
 */

Inline BOOL
sense_context()
{
	return(intnest > 0);
}

Inline BOOL
i_sense_lock()
{
	return(FALSE);
}

Inline BOOL
sense_lock()
{
	return(current_ccr() & H8INT_MASK_ALL);
}

#define t_sense_lock	sense_lock

/*
 *  CPUåȤβʥƥѡ
 */

Inline void
t_lock_cpu()
{
	disint();
}

Inline void
t_unlock_cpu()
{
	enaint();
}

/*
 *  CPUåȤβ󥿥ƥѡ
 */

extern UB	int_intmask;	/* 󥿥ƥȤǤγߥޥ */

Inline void
i_lock_cpu()
{
	UB	intmask;

	/*
	 *  ѿ intmask ȤäƤΤϡcurrent_intmask()Ƥ
	 *  ľ˳ߤȯư줿ߥϥɥ
	 *  int_intmask ѹǽ뤿Ǥ롥
	 */
	intmask = current_intmask();
	disint();
	int_intmask = intmask;
}

Inline void
i_unlock_cpu()
{
	set_intmask(int_intmask);
}

/*
 *  ǥѥå
 */

/*
 *  ǹ̥ͥؤΥǥѥåcpu_support.S
 *
 *  dispatch ϡƥȤƤӽФ줿ӥ
 *  ǡCPUå֤ǸƤӽФʤФʤʤ
 */

extern void	dispatch(void);

/*
 *  ߤΥƥȤΤƤƥǥѥåcpu_support.S
 *
 *  exit_and_dispatch ϡCPUå֤ǸƤӽФʤФʤʤ
 */

extern void	exit_and_dispatch(void);

/*
 *
 *  ߥϥɥ
 *
 *  ٥ȥֹ inhno γߥϥɥεưϤ inthdr ꤹ롥
 *
 */

Inline void
define_inh(INHNO inhno, FP inthdr)
{
}

/*
 *   CPU㳰ϥɥ
 */

Inline void
define_exc(EXCNO excno, FP exchdr)
{
}

/*
 *  ߥϥɥν
 *
 */

/*
 *  ߥϥɥνޥ
 *		ʼ
 *
 *  reqflg å˳ߤػߤʤȡreqflg å
 *  ˵ư줿ߥϥɥǥǥѥå׵ᤵ줿ˡǥ
 *  ѥåʤ
 *
 *
 */

/*  C롼δؿ̾Υ٥  */

#define	INT_ENTRY(inthdr)	inthdr##_entry
#define	EXC_ENTRY(exchdr)	exchdr##_entry

/*
 *  ߥϥɥ
 *
 *	H8ǤϡߤCPU㳰ΰƱʤΤǡ
 *	Υޥⶦ̤Ƥ
 *
 *	entryΥ٥
 *	inthdrC롼Ƭɥ쥹
 *
 */

#define	_INTHDR_ENTRY(entry, inthdr) 					   \
asm(".text								\n"\
"	.align 2							\n"\
"	.global _"#entry"						\n"\
"_"#entry ":								\n"\
			/*  ɬ׺Ǿ¤Υ쥸򥹥å  */	   \
"	push.l	er0							\n"\
"	push.l	er1							\n"\
			/*  ߥͥȥ󥿤Υå 		*/ \
"	mov.l	@_intnest, er0						\n"\
"	mov.l	er0, er1   						\n"\
				/*  ߥͥȥ󥿤 +1 */	   \
"	inc.l	#1, er0							\n"\
"	mov.l	er0, @_intnest						\n"\
				/* ȯΥƥȤȽ  	*/ \
"	or.l	er1, er1   						\n"\
				/* ¿ųߤʤ饸   		*/ \
"	bne	_interrupt_from_int_"#inthdr"				\n"\
				/*  ̥ϡɥ߶ػ */	   \
"	jsr	@_"#inthdr"_disable_int					\n"\
				/* åؤ			*/ \
				/* åݥ󥿤¸        	*/ \
"	mov.l	sp, er0							\n"\
				/* ߥåڤؤ		*/ \
"	mov.l	#"str_STACKTOP", sp					\n"\
				/* ߵ				*/ \
"	andc	#"str_H8INT_ENA_ALL", ccr				\n"\
				/*  ĤΥ쥸¸ */		   \
"	mov.l	er2, @-er0						\n"\
"	mov.l	er3, @-er0						\n"\
"	mov.l	er4, @-er0						\n"\
"	mov.l	er5, @-er0						\n"\
"	mov.l	er6, @-er0						\n"\
"	push.l	er0							\n"\
"	jsr	@_"#inthdr"						\n"\
				/* ߶ػ				*/ \
"	orc	#"str_H8INT_DIS_ALL", ccr				\n"\
				/*  ̥ϡɥߵ */	   \
"	jsr	@_"#inthdr"_enable_int					\n"\
				/* ߥͥȥ󥿤-1 */		   \
"	mov.l	@_intnest, er0					  	\n"\
"	dec.l	#1, er0							\n"\
"	mov.l	er0, @_intnest						\n"\
				/* åؤ  			*/ \
"	mov.l	@sp, sp							\n"\
				/* reqflgΥå                    	*/ \
"       mov.l	@__kernel_reqflg, er0							\n"\
			/* reqflgFALSEʤret_to_task_int 	*/ \
"	or.l	er0, er0						\n"\
"	beq	_ret_to_task_int_"#inthdr"				\n"\
				/*  reqflg򥯥ꥢ  		      	*/ \
"	sub.l	er0, er0						\n"\
"       mov.l	er0, @__kernel_reqflg					\n"\
				/*  ret_intإ  			*/ \
"	jmp	@_kernel_ret_int					\n"\
									   \
									   \
/*   ¿ųߤν 							*/ \
/* 	ȯΥƥȤȽ̸塢߶ػ		*/ \
/* 	ξ֤ǤǤ 					*/ \
/* 	ʳߥͥȥ󥿤Υ󥯥ȤϺѤǤ 		*/ \
									   \
"_interrupt_from_int_"#inthdr":						\n"\
				/*  ̥ϡɥ߶ػ */	   \
"	jsr	@_"#inthdr"_disable_int					\n"\
				/* ߵ				*/ \
"	andc	#"str_H8INT_ENA_ALL", ccr				\n"\
				/*  ĤΥ쥸¸	  	*/ \
"	push.l	er2							\n"\
"	push.l	er3							\n"\
"	push.l	er4							\n"\
"	push.l	er5							\n"\
"	push.l	er6							\n"\
"	jsr	@_"#inthdr"						\n"\
				/* ߶ػ				*/ \
"	orc	#"str_H8INT_DIS_ALL", ccr				\n"\
				/*  ̥ϡɥߵ */	   \
"	jsr	@_"#inthdr"_enable_int					\n"\
				/* ߥͥȥ󥿤 -1 */		   \
"	mov.l	@_intnest, er0					  	\n"\
"	dec.l	#1, er0							\n"\
"	mov.l	er0, @_intnest						\n"\
									   \
									   \
/*   reqflgFALSEξν 						*/ \
									   \
"_ret_to_task_int_"#inthdr": \n"					   \
"	pop.l	er6	\n"	/*  쥸  			*/ \
"	pop.l	er5	\n"						   \
"	pop.l	er4	\n"						   \
"	pop.l	er3	\n"						   \
"	pop.l	er2	\n"						   \
"	pop.l	er1	\n"						   \
"	pop.l	er0	\n"						   \
"	rte		\n"	/*  ߸  			*/ \
)

/*  _INTHDR_ENTRY()ޥޤ  */

/*
 *  ߥϥɥνޥ
 *
 */

#define INTHDR_ENTRY(inthdr)				\
	extern void inthdr##_entry(void);		\
	_INTHDR_ENTRY(inthdr##_entry, inthdr)

/*
 *  CPU㳰ϥɥνޥ
 */

#define	EXCHDR_ENTRY(exchdr)	INTHDR_ENTRY(exchdr)

/*
 *  CPU㳰ȯΥƥ֤λ
 */

/*
 *  CPU㳰ȯΥƥȽ
 */

Inline BOOL
exc_sense_context(VP p_excinf)
{
	/* ӤΤϡ߼¹CPU㳰ʬ 		*/
	/*  ߥͥȥ󥿤󥯥ȤƤ뤿 	*/
	return(intnest > 1);
}

/*
 *  CPU㳰ȯCPUå֤λ
 */

Inline BOOL
exc_sense_lock(VP p_excinf)
{
	return(*((UW *)p_excinf) & (H8INT_MASK_ALL << 24));
}

/*
 *  ץå¸ν
 */

extern void	cpu_initialize(void);

/*
 *  ץå¸νλ
 */

extern void	cpu_terminate(void);

/*
 *  ̤ȯΥ顼ϻΥå¤
 */

typedef struct exc_stack {
	VW	er0;
	VW	er1;
	VW	er2;
	VW	er3;
	VW	er4;
	VW	er5;
	VW	er6;
	VW	pc;	/*  ץࡦ  	*/
} EXCSTACK;

/*
 * ̤ȯΥ顼 (cpu_config.c, cpu_support.S)
 */

extern void     cpu_experr(EXCSTACK *);

#endif /* _MACRO_ONLY_ */

#endif /* _CPU_CONFIG_H_ */
