/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 *
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: hw_serial.h,v 1.1 2001/11/12 13:38:30 abe Exp $
 */

#ifndef _HW_SERIAL_H_
#define _HW_SERIAL_H_

/*
 *  åȰ¸ꥢI/O⥸塼H8ѡ
 *  SCI1
 *  Υ⥸塼ˤäơXON/XOFFե椬Ԥ
 *  ƤΤǡTxDRxD2ܤǤ褤
 */

#include "sys_config.h"
#include "cpu_config.h"

#ifndef _MACRO_ONLY

/*
 *  ꥢݡȤΥϡɥ¸
 */

typedef struct hardware_serial_port_descripter {
	UW	base;	/* SCI Υ١ɥ쥹		*/
	UW	enaix;	/* SCI ߾֤κ	*/
} HWPORT;

#endif	/* of #ifndef _MACRO_ONLY */

/*
 *  ٥ݡȾ֥åν
 */

#define NUM_PORT	1	/* ݡȤ륷ꥢݡȤο */
#define PORT_ID1	1	/* SCI1 */

#define HWPORT1	{ SYSTEM_SCI, 0 }

#ifndef _MACRO_ONLY

/*
 *  ꥢݡȤν
 */

Inline void
SCI_initialize(UW base)
{
    int i;
					/* 		*/
    outb(base + H8SCR, inb(base + H8SCR) & ~(H8SCR_TE | H8SCR_RE));

    					/* եޥå	*/
         		/* ĴƱ				*/
         		/* 饯󥰥8ӥå		*/
         		/* ѥƥʤ				*/
         		/* ȥåץӥåȥ󥰥1		*/
         		/* å쥯ȡʬ		*/
    outb(base + H8SMR, 0);

    outb(base + H8BRR, H8BRR_RATE);	/*  ܡ졼  	*/

    			/* ߶ػߤȥå	*/
    outb(base + H8SCR,
     inb(base + H8SCR) & ~(H8SCR_TIE  | H8SCR_RIE  |
                           H8SCR_MPIE | H8SCR_TEIE |
                           H8SCR_CKE1 | H8SCR_CKE0 ));

    /* ܡ졼Ȥ塢1ӥåʬԤʤФʤʤ*/

    for(i = SCI_SETUP_COUNT; i -- > 0; )
    	;

    				/* 顼ե饰򥯥ꥢ		*/
    outb(base + H8SSR,
     inb(base + H8SSR) & ~(H8SSR_ORER | H8SSR_FER | H8SSR_PER));

    /* ߵ, ߤεĤؿǹԤ	*/
    /*  */

    outb(base + H8SCR,
     inb(base + H8SCR) | (H8SCR_RIE | H8SCR_TE | H8SCR_RE));
}

/*
 * serial_openserial_close [systask/serial.c] ƤФ
 * ؿǤϲ⤷ʤ
 * sys_initialize [config/h8/akih8_3048f/sys_config.c] ǹԤ
 */

Inline BOOL
hw_port_initialize(HWPORT *p)
{
	return (FALSE);
}

Inline void
hw_port_terminate(HWPORT *p)
{
}

/*
 *  ꥢݡȳߥӥ롼ȡ
 */

extern void	serial_handler_in(int portid);
extern void	serial_handler_out(int portid);

/*
 *  ꥢI/OݡȤγߥϥɥ
 */

Inline void
hw_serial_handler_in()
{
	serial_handler_in(PORT_ID1);

    	/* 顼ե饰򥯥ꥢ		*/
	outb(H8SCI1 + H8SSR,
	 inb(H8SCI1 + H8SSR) & ~(H8SSR_ORER | H8SSR_FER | H8SSR_PER));

}

Inline void
hw_serial_handler_out()
{
	serial_handler_out(PORT_ID1);
}

/*
 *  ʸ
 */

Inline BOOL
hw_port_getready(HWPORT *p)
{
	/*  쥷֥ǡ쥸ե롦ե饰Υå  */
	return(inb(p->base + H8SSR) & H8SSR_RDRF);
}

/*
 *  ʸǤ뤫
 */

Inline BOOL
hw_port_putready(HWPORT *p)
{
	/*  ȥ󥹥ߥåȥǡ쥸ץƥե饰Υå*/

	return(inb(p->base + H8SSR) & H8SSR_TDRE);
}

/*
 *  ʸμФ
 */

Inline UB
hw_port_getchar(HWPORT *p)
{
	UB data;
	UW addr = p->base + H8SSR;

	data = inb(p->base + H8RDR);

 	/*  쥷֥ǡ쥸ե롦ե饰Υꥢ  */

#define BITCLR(bit)	Asm("bclr #" bit ", @%0" : : "r"(addr))
	BITCLR(_TO_STRING(H8SSR_RDRF_BIT));
#undef  BITCLR

	return data;
}

/*
 *  ʸν񤭹
 */

Inline void
hw_port_putchar(HWPORT *p, UB c)
{
	UW addr = p->base + H8SSR;

	outb(p->base + H8TDR, c);

#define BITCLR(bit)	Asm("bclr #" bit ", @%0" : : "r"(addr))
	BITCLR(_TO_STRING(H8SSR_TDRE_BIT));
#undef  BITCLR
}

/*
 * ľܽ (Ԥ)
 */

Inline void
SCI_putchar (int base, int c)
{
	UW addr = base + H8SSR;

	/* TDRE  1 ˤʤޤԤ */
	while ((inb(addr) & H8SSR_TDRE) == 0)
		;
	outb(base + H8TDR, c);

#define BITCLR(bit)	Asm("bclr #" bit ", @%0" : : "r"(addr))
	BITCLR(_TO_STRING(H8SSR_TDRE_BIT));
#undef  BITCLR

	}

/*
 *  ؿ
 */

Inline void
hw_port_sendstart(HWPORT *p)
{
	UW addr = p->base + H8SCR;

#define BITSET(bit)	Asm("bset #" bit ", @%0" : : "r"(addr))
	BITSET(_TO_STRING(H8SCR_TIE_BIT));
#undef  BITSET
}

Inline void
hw_port_sendstop(HWPORT *p)
{
	UW addr = p->base + H8SCR;

#define BITCLR(bit)	Asm("bclr #" bit ", @%0" : : "r"(addr))
	BITCLR(_TO_STRING(H8SCR_TIE_BIT));
#undef  BITCLR
}

#endif	/* of #ifndef _MACRO_ONLY */

#endif /* _HW_SERIAL_H_ */
