/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: hw_timer.h,v 1.1 2001/11/12 13:38:30 abe Exp $
 */

#ifndef _HW_TIMER_H_
#define _HW_TIMER_H_

/*
 *  CPU¸ޥ⥸塼H8ѡ
 *  ITU0
 */

#include "sys_defs.h"
#include "sys_config.h"
#include "cpu_config.h"

/*
 *  ͤɽη
 */

typedef UH	CLOCK;

/*
 *  ޼ñ̤ɽѴ
 *  	jsp/kernel/time_manage.cǤ
 */

#define TO_CLOCK(nume, deno)	(TIMER_CLOCK * (nume) / (deno))

/*
 *  ޼ñ̤ɽѴ
 */

#define CLOCK_PER_TICK	((CLOCK) TO_CLOCK(TIC_NUME, TIC_DENO))

/*
 *  ǤΥ޼ñ̤ɽ
 */

#define MAX_CLOCK	((CLOCK) 0xffff)

/*
 *  ǽɾѥƥФݤν֤θѤ
 *	ñ̤ɽ
 *	աʬå˰¸
 */

#define GET_TOLERANCE	100

/*
 *  ޳׵Υꥢ
 *	TCR쥸IMFAӥåȤ1ɤ߽Фˣ񤭹
 */

Inline void
hw_timer_int_clear(void)
{
    /* GRAڥޥåγ׵ե饰򥯥ꥢ */
    /*outb(SYSTEM_ITU + H8TSR, inb(SYSTEM_ITU + H8TSR) & ~H8TSR_IMIFA);*/
    UW addr = SYSTEM_ITU + H8TSR;

#define BITCLR(bit)	Asm("bclr #" bit ", @%0" : : "r"(addr))
	BITCLR(_TO_STRING(H8TSR_IMIFA_BIT));
#undef  BITCLR
}

/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ롥
 */

Inline void
hw_timer_initialize()
{
    UW addr = H8ITU_TSTR;

    /*  */
    /*outb(H8ITU_TSTR, inb(H8ITU_TSTR) & ~SYSTEM_STR);*/

#define BITCLR(bit)	Asm("bclr #" bit ", @%0" : : "r"(addr))
	BITCLR(_TO_STRING(SYSTEM_STR_BIT));
#undef  BITCLR

    /*  GRAڥޥåǥ󥿤򥯥ꥢʬ */
    outb(SYSTEM_ITU + H8TCR, H8TCR_CCLR | H8TCR_CKEG | H8TCR_TPSC);

    /*  GRAڥޥåˤ׵ */
    outb(SYSTEM_ITU + H8TIER, SYSTEM_ITU_IE);

    /*  GRAڥޥåˤüҽ϶ػ */
    outb(SYSTEM_ITU + H8TIOR, H8TIOR_IOB | H8TIOR_IOA);

    /*  GRA쥸ʥɸ͡  	*/
    outw(SYSTEM_ITU + SYSTEM_GR, CLOCK_PER_TICK);

    outw(SYSTEM_ITU + H8TCNT, 0);	/* 󥿤򥯥ꥢ	*/

    hw_timer_int_clear();		/*  ׵򥯥ꥢ  */

    /* ޥ */
    /*outb(H8ITU_TSTR, inb(H8ITU_TSTR) | SYSTEM_STR);*/

#define BITSET(bit)	Asm("bset #" bit ", @%0" : : "r"(addr))
	BITSET(_TO_STRING(SYSTEM_STR_BIT));
#undef  BITSET
}

/*
 *  ޤ߽
 */

Inline void
hw_timer_terminate()
{
    UW addr = H8ITU_TSTR;

    /*  */
    /*outb(H8ITU_TSTR, inb(H8ITU_TSTR) & ~SYSTEM_STR);*/

#define BITCLR(bit)	Asm("bclr #" bit ", @%0" : : "r"(addr))
	BITCLR(_TO_STRING(SYSTEM_STR_BIT));
#undef  BITCLR

    hw_timer_int_clear();		/* ׵򥯥ꥢ */
}

/*
 *  ޤθͤɤ߽Ф
 *
 *  ߶ػ߶ǸƤӽФȡ
 */

Inline CLOCK
hw_timer_get_current(void)
{
	return(CLOCK_PER_TICK - (CLOCK)(inw(SYSTEM_ITU + H8TCNT)));
}

/*
 *  ޳׵Υå
 */

Inline BOOL
hw_timer_fetch_interrupt(void)
{
	return(inb(SYSTEM_ITU + H8TSR) & H8TSR_IMIFA);
}

#endif /* _HW_TIMER_H_ */
