/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: hw_serial.h,v 1.3 2001/11/15 01:54:58 hiro Exp $
 */

/*
 *	åȰ¸ꥢI/O⥸塼DVE68K/40ѡ
 */

#ifndef _HW_SERIAL_H_
#define _HW_SERIAL_H_

#include "dve68k.h"
#include "sys_config.h"

/*
 *  ꥢݡȤΥϡɥ¸
 */
typedef struct hardware_serial_port_descripter {
	INT	*initflag;	/* ѥե饰ؤΥݥ */
	IOREG	*data;		/* ǡ쥸 */
	IOREG	*cntrl;		/* ȥ쥸 */
	BOOL	sendflag;	/* ߥ֥͡ե饰 */

	byte	cr3_def;	/* ǥեȤ (CR3) */
	byte	cr4_def;	/* ǥեȤ (CR4) */
	byte	cr5_def;	/* ǥեȤ (CR5) */
	byte	brg2_def;	/* ǥեȤ (ܡ졼Ȳ) */
	byte	brg1_def;	/* ǥեȤ (ܡ졼Ⱦ) */
} HWPORT;

/*
 *  MPSCȥ쥸
 */

#define MPSC_RESET	0x18		/* ݡȥꥻåȥޥ */
#define MPSC_EOI	0x38		/* EOI (End of Interrupt) */

#define CR3_DEF		0xc1		/* ǡ 8bit, ֥͡ */
#define CR4_DEF		0x44		/* ȥåץӥå 1bit, ѥƥʤ */
#define CR5_DEF		0xea		/* ǡ 8bit, ֥͡ */
#define BRG2_DEF	0x1e		/* 9600bps () */
#define BRG1_DEF	0x00		/* 9600bps () */

#define CR10_DEF	0x00		/* NRZ */
#define CR14_DEF	0x07		/* ܡ졼ȥͥ졼֥͡ */
#define CR15_DEF	0x56		/* ܡ졼ȥͥ졼 */

#define CR1_ALL		0x12		/* ߤ */
#define CR1_RECV	0x10		/* ߤΤߵ */
#define CR1_DOWN	0x00		/* ߤػ */

/*
 *  ꥢI/OγߥϥɥΥ٥ֹ
 */
#define INHNO_SERIAL	GP0_VEC

/*
 *  ٥ݡȾ֥åν
 */

#define NUM_PORT	2	/* ݡȤ륷ꥢݡȤο */

static INT	initflag[2] = { 0, 0 } ;	/* ѥե饰 */

#define HWPORT1		{ &initflag[0], MPSC_DATAA, MPSC_CNTRLA, 0,	\
			  CR3_DEF, CR4_DEF, CR5_DEF, BRG2_DEF, BRG1_DEF }
#define HWPORT2		{ &initflag[1], MPSC_DATAB, MPSC_CNTRLB, 0,	\
			  CR3_DEF, CR4_DEF, CR5_DEF, BRG2_DEF, BRG1_DEF }

/*
 *  ꥢI/OݡȤν
 */
Inline BOOL
hw_port_initialize(HWPORT *p)
{
	/*
	 *  MPSC 
	 */
	io_write(p->cntrl, MPSC_RESET);
	if (initflag[0] <= 0 && initflag[1] <= 0) {
		mpsc_write(MPSC_CNTRLA, MPSC_CR2, 0x18);
		mpsc_write(MPSC_CNTRLB, MPSC_CR2, 0x00);
	}
	mpsc_write(p->cntrl, MPSC_CR1, CR1_RECV);
	p->sendflag = 0;
	mpsc_write(p->cntrl, MPSC_CR4, p->cr4_def);
	mpsc_write_brg(p->cntrl, MPSC_CR12, 0x01, p->brg2_def, p->brg1_def);
	mpsc_write_brg(p->cntrl, MPSC_CR12, 0x02, p->brg2_def, p->brg1_def);
	mpsc_write(p->cntrl, MPSC_CR15, CR15_DEF);
	mpsc_write(p->cntrl, MPSC_CR14, CR14_DEF);
	mpsc_write(p->cntrl, MPSC_CR10, CR10_DEF);
	mpsc_write(p->cntrl, MPSC_CR3, p->cr3_def);
	mpsc_write(p->cntrl, MPSC_CR5, p->cr5_def);

	/*
	 *  ߴϢ
	 */
	if (initflag[0] <= 0 && initflag[1] <= 0) {
		dga_set_ilv(DGA_CSR25, GP0IL_BIT, IRQ_LEVEL6);
						/* ߥ٥ */
		*DGA_CSR21 |= GP0_BIT;		/* ߥޥ */
	}

	*(p->initflag) = 1;			/* ե饰 */
	return(FALSE);
}

/*
 *  ꥢI/OݡȤνλ
 */
Inline void
hw_port_terminate(HWPORT *p)
{
	*(p->initflag) = -1;			/* ե饰 */

	/*
	 *  MPSC γߴط
	 */
	mpsc_write(p->cntrl, MPSC_CR1, CR1_DOWN);
	p->sendflag = 0;

	/*
	 *  ߴϢ
	 */
	if (initflag[0] <= 0 && initflag[1] <= 0) {
		*DGA_CSR21 &= ~GP0_BIT;		/* ߥޥ */
	}
}

/*
 *  ꥢݡȳߥӥ롼ȡ
 */
extern void	serial_handler_in(ID portid);
extern void	serial_handler_out(ID portid);

/*
 *  ꥢI/OݡȤγߥϥɥ
 */
Inline void
hw_serial_handler()
{
	if (initflag[0] > 0) {
		serial_handler_in(1);
		serial_handler_out(1);
	}
	if (initflag[1] > 0) {
		serial_handler_in(2);
		serial_handler_out(2);
	}
	mpsc_write(MPSC_CNTRLA, MPSC_CR0, MPSC_EOI);
}

/*
 *  ʸ
 */
Inline BOOL
hw_port_getready(HWPORT *p)
{
	return((mpsc_read(p->cntrl, MPSC_SR0) & 0x01) != 0);
}

/*
 *  ʸǤ뤫
 */
Inline BOOL
hw_port_putready(HWPORT *p)
{
	return((mpsc_read(p->cntrl, MPSC_SR0) & 0x04) != 0);
}

/*
 *  ʸμФ
 */
Inline byte
hw_port_getchar(HWPORT *p)
{
	return(io_read(p->data));
}

/*
 *  ʸν񤭹
 */
Inline void
hw_port_putchar(HWPORT *p, byte c)
{
	io_write(p->data, c);
}

/*
 *  ؿ
 */
Inline void
hw_port_sendstart(HWPORT *p)
{
	if (!(p->sendflag)) {
		mpsc_write(p->cntrl, MPSC_CR1, CR1_ALL);
		p->sendflag = 1;
	}
}

Inline void
hw_port_sendstop(HWPORT *p)
{
	if (p->sendflag) {
		mpsc_write(p->cntrl, MPSC_CR1, CR1_RECV);
		p->sendflag = 0;
	}
}

#endif /* _HW_SERIAL_H_ */
