/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: hw_timer.h,v 1.2 2001/09/25 15:13:45 hiro Exp $
 */

/*
 *	åȰ¸ޥ⥸塼DVE68K/40ѡ
 */

#ifndef _HW_TIMER_H_
#define _HW_TIMER_H_

#include "dve68k.h"

/*
 *  ޳ߥϥɥΥ٥ֹ
 */
#define	INHNO_TIMER	TT0_VEC

/*
 *  ͤɽη
 */
typedef UW	CLOCK;

/*
 *  ͤɽȥߥñ̤ȤѴ
 *
 *  DVE68K/40 CPUܡɤǤϡޤ1˥ȥåפ롥
 */
#define TIMER_CLOCK		1000
#define TO_CLOCK(nume, deno)	(TIMER_CLOCK * (nume) / (deno))

/*
 *  ǤΥ޼ñ̤ɽ
 */
#define MAX_CLOCK	((CLOCK) 0xffffff)

/*
 *  ǽɾѥƥФݤν֤θѤ͡ñ̤ɽ
 */
#define GET_TOLERANCE	100

/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ롥
 */
Inline void
hw_timer_initialize()
{
	CLOCK	c = TO_CLOCK(TIC_NUME, TIC_DENO);

	/*
	 *  ޴Ϣ
	 */
	assert(c <= MAX_CLOCK);		/* ޼ξͤΥå */
	*DGA_CSR12 = 0x80000000 | c;	/* ͤꡤޥ */

	/*
	 *  ߴϢ
	 */
	dga_set_ilv(DGA_CSR25, TT0IL_BIT, IRQ_LEVEL4);
					/* ߥ٥ */
	*DGA_CSR23 = TT0_BIT;		/* ׵򥯥ꥢ */
	*DGA_CSR21 |= TT0_BIT;		/* ߥޥ */
}

/*
 *  ޳׵Υꥢ
 */
Inline void
hw_timer_int_clear()
{
	*DGA_CSR23 = TT0_BIT;		/* ޳׵򥯥ꥢ */
}

/*
 *  ޤ߽
 *
 *  ޤưߤ롥
 */
Inline void
hw_timer_terminate()
{
	*DGA_CSR12 &= 0x7fffffff;	/* ޤ */
	*DGA_CSR21 &= ~TT0_BIT;		/* ߥޥ */
	*DGA_CSR23 = TT0_BIT;		/* ׵򥯥ꥢ */
}

/*
 *  ޤθͤɽФ
 */
Inline CLOCK
hw_timer_get_current(void)
{
	CLOCK	c;

	*DGA_CSR12 &= 0x7fffffff;	/* ޤ */
	cpu_wait_io();			/* ޤߤΤԤ */
	cpu_wait_io();
	c = *DGA_CSR13 & 0x00ffffff;
	*DGA_CSR12 |= 0x80000000;	/* ޥ */
	return(c);
}

/*
 *  ޳׵Υå
 */
Inline BOOL
hw_timer_fetch_interrupt(void)
{
	return(*DGA_CSR20 & TT0_BIT);
}

#endif /* _HW_TIMER_H_ */
