/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 *
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: hw_serial.h,v 1.2 2001/10/22 02:16:43 imai Exp $
 */

#ifndef _HW_SERIAL_H_
#define _HW_SERIAL_H_

/*
 *  åȰ¸ꥢI/O⥸塼ʾ׾ SH1/CPUBѡ
 *  SCI0
 *  Υ⥸塼ˤäơXON/XOFFե椬Ԥ
 *  ƤΤǡTxDRxD2ܤǤ褤
 */

#include "sh1.h"
#include "sys_config.h"
#include "cpu_config.h"

/*
 *  ꥢI/OγߥϥɥΥ٥ֹ
 */
#define INHNO_SERIAL_IN	 RXI0
#define INHNO_SERIAL_OUT TXI0
/*
 *  顼ϤƤʤ
 * #define INHNO_SERIAL_ERROR  SCI_BRI_INTEVT
 */


/*
 *  ꥢݡȤΥϡɥ¸
 */
typedef struct hardware_serial_port_descripter {
    INT	  *initflag;	   /* ѥե饰ؤΥݥ   */
    BOOL  sendflag;        /* ߥ֥͡ե饰 */
} HWPORT;



/*
 * SCIγߥ٥
 * ߥϥɥ̡ϿǤ뤬ߥ٥
 * Ʊ٥ˤǤʤ
 */
#define SCIINTLVL	6	/*    */
#define LEVEL0		0	/*  ߲Υ٥  */
#define SCI_SHIFT	0	/*  ߥ٥ϿΥӥåȥե  */


/*
 *  ٥ݡȾ֥åν
 */

#define NUM_PORT	1	/* ݡȤ륷ꥢݡȤο */

static INT	initflag[NUM_PORT] = { 0 } ;	/* ѥե饰 */
#define HWPORT1	{ &initflag[0],  0 }

/*
 *ץPORT1ϡSCI0ؤƤ
 */
#define PORT_ID1	1
#define PORT_INDEX1	0


/*
 *  ꥢI/OݡȤν
 */
Inline BOOL
hw_port_initialize(HWPORT *p)
{
    int i;

    SCI.SCR0 &= ~(SCR_TE | SCR_RE);	/*    */
    					/*  ԥ󥢥  */
    					/*  	PB8:RxD0 PB9:TxD0  */
    *PBCR1 = (*PBCR1 & PBCR1_TD0_RD0_MASK) |
    		PBCR1_TD0 | PBCR1_RD0;
    					/*  եޥå  */
    SCI.SMR0 = 	SMR_CA_ASYNC |	/*  ĴƱ  		*/
    		SMR_CHR8 |	/*  饯󥰥8ӥå */
    		SMR_PE_NON |	/*  ѥƥʤ  		*/
    		SMR_STOP1 |	/*  ȥåץӥåȥ󥰥1 	*/
    		SMR_CKS;	/*  å쥯ȡʬ  */
    				/*  sys_config.h  		*/
    SCI.BRR0 = SCI_BRR;		/*  ܡ졼  	*/
    				/*  sys_config.h  	*/

    				/*  ߶ػߤȥå */
    SCI.SCR0 = (IOREG)(~(SCR_TIE | SCR_RIE | SCR_TE | SCR_RE |
    		  SCR_MPIE | SCR_TEIE | SCR_CKE_MASK) | SCR_CKE);

    /*
     * ܡ졼Ȥ塢1ʬԤʤФʤʤ
     */
    for(i=0; i<WAIT_TIME; i++);	/*  sys_config.h  	*/

    				/* 顼ե饰򥯥ꥢ		*/
    SCI.SSR0 &= ~(SSR_ORER | SSR_FER | SSR_PER);
    				/* ߵ   	*/
    				/*   		*/
    SCI.SCR0 |= (SCR_RIE | SCR_TE | SCR_RE);
    		/*  ߤεĤؿǹԤ  */

    /*
     * ߴϢ
     * 顼ϥɥϿ٤
     */
    if (initflag[PORT_INDEX1] <= 0) {
        			/* ߥ٥ */
        define_int_plevel(IPRD, SCIINTLVL, SCI_SHIFT);
    }

    *(p->initflag) = 1;			/* ե饰 */
    return(FALSE);
}

/*
 *  ꥢI/OݡȤνλ
 */
Inline void
hw_port_terminate(HWPORT *p)
{
    *(p->initflag) = -1;		/* ե饰     */
    SCI.SCR0 &= ~(SCR_TE | SCR_RE);	/*    	*/
    					/* ߥ٥륯ꥢ */
    define_int_plevel(IPRD, LEVEL0, SCI_SHIFT);
}

/*
 *  ꥢݡȳߥӥ롼ȡ
 */
extern void	serial_handler_in(int portid);
extern void	serial_handler_out(int portid);


/*
 *  ꥢI/OݡȤγߥϥɥ
 */
Inline void
hw_serial_handler_in()
{
    if (initflag[PORT_INDEX1] > 0)
        serial_handler_in(PORT_ID1);
    else
    	/*  Ƥʤϼߤػ  */
        SCI.SCR0 &= ~SCR_RIE;
}

Inline void
hw_serial_handler_out()
{
    if (initflag[PORT_INDEX1] > 0)
        serial_handler_out(PORT_ID1);
    else
    	/*  Ƥʤߤػ  */
        SCI.SCR0 &= ~SCR_TIE;
}


/*
 *  ʸ
 */
Inline BOOL
hw_port_getready(HWPORT *p)
{
	/*  쥷֥ǡ쥸ե롦ե饰Υå  */
	return(SCI.SSR0 & SSR_RDRF);
}

/*
 *  ʸǤ뤫
 */
Inline BOOL
hw_port_putready(HWPORT *p)
{
	/*  ȥ󥹥ߥåȥǡ쥸ץƥե饰Υå*/
	return(SCI.SSR0 & SSR_TDRE);
}

/*
 *  ʸμФ
 */
Inline byte
hw_port_getchar(HWPORT *p)
{
    byte data;
    data = SCI.RDR0;
 	/*  쥷֥ǡ쥸ե롦ե饰Υꥢ  */
    SCI.SSR0 &= ~SSR_RDRF ;
    return data;
}

/*
 *  ʸν񤭹
 */
Inline void
hw_port_putchar(HWPORT *p, byte c)
{
    SCI.TDR0 = c;
	/*  ȥ󥹥ߥåȥǡ쥸ץƥե饰Υꥢ*/
    SCI.SSR0 &= ~SSR_TDRE;
}

/*
 *  ؿ
 */
Inline void
hw_port_sendstart(HWPORT *p)
{
    if (!(p->sendflag)) {
        SCI.SCR0 |= SCR_TIE;   /* ׵ */
        p->sendflag = 1;
    }
}

Inline void
hw_port_sendstop(HWPORT *p)
{
    if (p->sendflag) {
        SCI.SCR0 &= ~SCR_TIE; /* ׵ػ */
        p->sendflag = 0;
    }
}

#endif /* _HW_SERIAL_H_ */
