/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: card_e09a.h,v 1.2 2001/10/19 14:20:47 honda Exp $
 */

#ifndef _CARD_E09A_ 
#define _CARD_E09A_ 

#include "sh3.h"




/*
 *  ISHܡɾΥǥХåLEDȥȥ顼Υɥ쥹
 */

#define ISH_LED1         (*(IOREG *)0xBBC00080)
#define ISH_LED2         (*(IOREG *)0xBBC00081)
#define ISH_LED_CONTROL  (*(HIOREG *)0xB1000780)


/*
 *  LEDΥȥ顼˥饤
 */
Inline void
led_init(void)
{
    ISH_LED_CONTROL = 0x0080;
}

/*
 *LEDݡȤؤν
 */

Inline void
led_set(HIOREG led_data)
{
    ISH_LED1 = (IOREG)led_data;
    ISH_LED2 = (IOREG)(led_data >> 8);
}



/*
 *  CARD-E09AΥϡɥ񸻤
 */



/*
 * CARD-E09Aγߥȥ
 */

#define CARD_E09A_IER1    ((HIOREG *)(0xb1000000))  
#define CARD_E09A_IER2    ((HIOREG *)(0xb1000002))  
#define CARD_E09A_SR1     ((HIOREG *)(0xb1000004))  
#define CARD_E09A_SR2     ((HIOREG *)(0xb1000006))  

    
/*
 *  CARD-E09A16550ߴserial3
 */

typedef struct{
    HIOREG  data;
    HIOREG  IE;
    HIOREG  II;
    HIOREG  LC;
    HIOREG  MC;
    HIOREG  LS;
    HIOREG  MS;
    HIOREG  scratch;
} CARD_E09A_serial_t;

#define CARD_E09A_SERIAL     (*(volatile CARD_E09A_serial_t *)0xb1000200)

/*
 *  For IE
 */
#define IER_EDSSI     0x08
#define IER_ELSI      0x04
#define IER_ETBEI     0x02
#define IER_ERBFI     0x01

/*
 *  For II
 */
#define IIR_ID        0x06
#define IIR_IP        0x01

/*
 *  For LC
 */
#define LCR_DLAB      0x80
#define LCR_SB        0x40
#define LCR_SP        0x20
#define LCR_EPS       0x10
#define LCR_PEN       0x08
#define LCR_STB       0x06
#define LCR_WLS       0x01

 /*
  *  For LS 
  */
#define LSR_TEMT      0x40
#define LSR_THRE      0x20
#define LSR_BI        0x10
#define LSR_FE        0x08
#define LSR_PE        0x04
#define LSR_OE        0x02
#define LSR_DR        0x01


#endif /*  _CARD-E09A_ */



