/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: hw_serial.h,v 1.2 2001/10/19 14:20:47 honda Exp $
 */

#ifndef _HW_SERIAL_H_
#define _HW_SERIAL_H_

/*
 *  åȰ¸ꥢI/O⥸塼CARD-E09Aѡ
 *  Companion Chip16550ߴserial3
 */


#include "sh3.h"
#include "card_e09a.h"
#include "sys_config.h"
#include "cpu_config.h"


/*
 *  ꥢI/OγߥϥɥΥ٥ֹ
 */
#define INHNO_SERIAL	 IRQ0_INTEVT

/*
 *  ꥢݡȤΥϡɥ¸
 *  Not yet! m68kΤ褦˥ȥ쥸¤Τˤ롣
 */
typedef struct hardware_serial_port_descripter {
    INT	    *initflag;	   /* ѥե饰ؤΥݥ   */
    BOOL    sendflag;      /* ߥ֥͡ե饰 */
} HWPORT;



/*
 *  SCIFγߥ٥
 *  Ʊꤹ롣
 */

#define SCIFINTLVL   6


/*
 *  ٥ݡȾ֥åν
 */

#define NUM_PORT	1	/* ݡȤ륷ꥢݡȤο */

static INT	initflag[1] = { 0 } ;	/* ѥե饰 */

#define HWPORT1	{ &initflag[0],  0 }





/*
 *  ꥢI/OݡȤν
 */

Inline BOOL
hw_port_initialize(HWPORT *p)
{
    CARD_E09A_SERIAL.LS = 0x00;
    *CARD_E09A_IER1 = 0x10;
    CARD_E09A_SERIAL.IE =  IER_ERBFI;
    if (initflag[0] <= 0) {
        *IPRC=(*IPRC&0xfff0)|(SCIFINTLVL);        /* ߥ٥ */
        define_int_plevel(IRQ0_INTEVT,SCIFINTLVL);
        *ICR1 = 0x02;
    }
    
    *(p->initflag) = 1;			/* ե饰 */
    return(FALSE);
}

/*
 *  ꥢI/OݡȤνλ
 */
Inline void
hw_port_terminate(HWPORT *p)
{
    
	*(p->initflag) = -1;			/* ե饰 */
    SCIF.SCSCR2 = 0x00;                  /* ꥢ륳ȥ */
	CARD_E09A_SERIAL.IE =  0x00;
    
    /*
	 *  ߴϢ
	 */
    *IPRC=(*IPRC&0xfff0);                   /* ߥޥꥢ */
}


/*
 *  ꥢݡȳߥӥ롼ȡ
 */
extern void	serial_handler_in(int portid);
extern void	serial_handler_out(int portid);


/*
 *  ꥢI/OݡȤγߥϥɥ
 */
Inline void
hw_serial_handler()
{
	if (initflag[0] > 0) {
		serial_handler_in(1);
		serial_handler_out(1);
	}
	/*	CARD_E09A_SERIAL.LS = 0x00; */
}


/*
 *  ʸ
 */
Inline BOOL
hw_port_getready(HWPORT *p)
{
  return((CARD_E09A_SERIAL.LS & 0x0001) != 0);
}

/*
 *  ʸǤ뤫
 */
Inline BOOL
hw_port_putready(HWPORT *p)
{
  return((CARD_E09A_SERIAL.LS & 0x0060) != 0);
}

/*
 *  ʸμФ
 */
Inline byte
hw_port_getchar(HWPORT *p)
{
    return(CARD_E09A_SERIAL.data);
}

/*
 *  ʸν񤭹
 */
Inline void
hw_port_putchar(HWPORT *p, byte c)
{
  CARD_E09A_SERIAL.data=c;
}

/*
 *  ؿ
 */
Inline void
hw_port_sendstart(HWPORT *p)
{
    if (!(p->sendflag)) {
        CARD_E09A_SERIAL.IE |= IER_ETBEI; /* ׵ */
        p->sendflag = 1;
	}
}

Inline void
hw_port_sendstop(HWPORT *p)
{
	if (p->sendflag) {
        CARD_E09A_SERIAL.IE &= ~IER_ETBEI; /* ׵ػ */
        p->sendflag = 0;
	}
}

#endif /* _HW_SERIAL_H_ */
