/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: hw_timer.h,v 1.3 2001/11/05 13:31:13 honda Exp $
 */

#ifndef _HW_TIMER_H_
#define _HW_TIMER_H_

/*
 *  CPU¸ޥ⥸塼SH3ѡ
 *  TMU0
 */


#include "sys_defs.h"
#include "cpu_config.h"

#if defined(SH7750)
#include "sh4.h"
#else
#include "sh3.h"
#endif /* SH7750 */

/*
 *  ޳ߥϥɥINTEVTֹ
 */
#define	INHNO_TIMER	TMU0_INTEVT

/*
 *  ͤɽη
 */
typedef UW	CLOCK;

/*
 *  ޡγߥ٥
 */

#define TINTLVL0        4


#define TO_CLOCK(nume, deno)	(TIMER_CLOCK * (nume) / (deno))

/*
 *  ǤΥ޼ñ̤ɽ
 */
#define MAX_CLOCK	((CLOCK) 0xffffffff)

/*
 *  ǽɾѥƥФݤν֤θѤ͡ñ̤ɽ
 */
#define GET_TOLERANCE	100

/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ롥
 */
Inline void
hw_timer_initialize()
{
	CLOCK	c = TO_CLOCK(TIC_NUME, TIC_DENO);
        
	/*
	 *  ޴Ϣ
	 */
    TMU.TSTR&=~TMU_STR0;             /*  */
    assert(c <= MAX_CLOCK);		     /* ޾ͤΥå */
    
    TMU.TCR0  = (0x020 | TCR0_TPSC); /* ʬꡢߵ */
    
    TMU.TCOR0 = c;                   /* timer constant쥸򥻥å */
    TMU.TCNT0 = c;                   /* 󥿡򥻥å */
    TMU.TSTR  |= TMU_STR0;           /* 0    */

    
    /*
	 *  ߴϢ
	 */
    define_int_plevel(TMU0_INTEVT,TINTLVL0); /* ߥ٥(SF) */
    *IPRA=(*IPRA&0x0fff)|(TINTLVL0<<12);     /* ߥ٥(HW) */
    TMU.TCR0 &= ~TCR_UNF;                    /* ׵򥯥ꥢ   */
}


/*
 *  ޳׵Υꥢ
 */
Inline void
hw_timer_int_clear()
{
    TMU.TCR0 &= ~TCR_UNF;                /* ׵򥯥ꥢ */
}

/*
 *  ޤ߽
 */
Inline void
hw_timer_terminate()
{
    TMU.TSTR&=~TMU_STR0;                  /* ޤ */
    TMU.TCR0 = 0;                         /* ׵򥯥ꥢ */
}

/*
 *  ޤθͤɤߤ
 *
 *  ߶ػ߶ǸƤӽФȡ
 */
Inline CLOCK
hw_timer_get_current(void)
{
	return(TO_CLOCK(TIC_NUME, TIC_DENO) - TMU.TCNT0);
}

Inline BOOL
hw_timer_fetch_interrupt(void)
{
	return(TMU.TCR0 & TCR_UNF);
}

#endif /* _HW_TIMER_H_ */



