/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: hw_serial.h,v 1.1 2001/11/05 13:34:25 honda Exp $
 */

#ifndef _HW_SERIAL_H_
#define _HW_SERIAL_H_

/*
 *  åȰ¸ꥢI/O⥸塼KZ_SH4ѡ
 *  SCIF
 */

#include "sh4.h"
#include "sys_config.h"
#include "cpu_config.h"


/*
 *  ꥢI/OγߥϥɥΥ٥ֹ
 */
#define INHNO_SERIAL_IN	 SCIF_RXI_INTEVT       
#define INHNO_SERIAL_OUT SCIF_TXI_INTEVT	
#define INHNO_SERIAL_ERROR  SCIF_BRI_INTEVT

/*
 *  ꥢݡȤΥϡɥ¸
 */
typedef struct hardware_serial_port_descripter {
    INT	  *initflag;	   /* ѥե饰ؤΥݥ   */
    BOOL  sendflag;        /* ߥ֥͡ե饰 */
} HWPORT;



/*
 * SCIFγߥ٥
 * Ʊꤹ롣
 */


#define SCIFINTLVL   6


/*
 *  ٥ݡȾ֥åν
 */

#define NUM_PORT	1	/* ݡȤ륷ꥢݡȤο */

static INT	initflag[1] = { 0 } ;	/* ѥե饰 */

#define HWPORT1	{ &initflag[0],  0 }


/*
 *  ꥢI/OݡȤν
 */
Inline BOOL
hw_port_initialize(HWPORT *p)
{
    
    *SCIF_SCSCR2  = 0;             /* SCI1,PåȤ     */
    *SCIF_SCFCR2  = SCFCR2_TFRST | SCFCR2_RFRST; /* FIFO򥯥ꥢ */
    *SCIF_SCSMR2  = 0;            /* 8ǡ,1ȥåץӥå,no parity   */
    *SCIF_SCSPTR2 = SCSPTR2_RTSIO;    /* ^RTS2 ˽                    */    
    *SCIF_SCBRR2  = SCIF_BPS_VALUE;        

    /*
     * ܡ졼Ȥ塢1ʬԤʤФʤʤ
     * ХơȥȥΥեå奫󥿤Ȥ
     * 1ʬԤ
     */

    *RFCR = RFCR_CLEAR;
    while( *RFCR < WAIT_RFCR_FOR_SCI);
        
    *SCIF_SCFCR2 = 0x30;           /* R-FIFO=1,T-FIFO=1 ȥꥬ */

    *SCIF_SCSCR2 = 0x0060;         /* 顼ե饰򥯥ꥢ           */
    *SCIF_SCSCR2 = 0x70;           /* Start Tx Rx ߵ   */
    
    /*
     * ߴϢ
     * 顼ϥɥϿ٤
     */
    if (initflag[0] <= 0) {
        *IPRC=(*IPRC&0xff0f)|(SCIFINTLVL<<4); /* ߥ٥ */
        define_int_plevel(SCIF_RXI_INTEVT,SCIFINTLVL);
        define_int_plevel(SCIF_TXI_INTEVT,SCIFINTLVL);
    }
    
    *(p->initflag) = 1;			/* ե饰 */

    return(FALSE);
}

/*
 *  ꥢI/OݡȤνλ
 */
Inline void
hw_port_terminate(HWPORT *p)
{
	*(p->initflag) = -1;		/* ե饰           */
    *SCIF_SCSCR2 = 0x00;         /* ꥢ륳ȥ */
    *IPRC=(*IPRC&0xff0f);       /* ߥޥꥢ       */
}

/*
 *  ꥢݡȳߥӥ롼ȡ
 */
extern void	serial_handler_in(int portid);
extern void	serial_handler_out(int portid);


/*
 *  ꥢI/OݡȤγߥϥɥ
 */
Inline void
hw_serial_handler_in()
{
    if (initflag[0] > 0)
        serial_handler_in(1);        
    else
        *SCIF_SCSCR2 &= ~(SCSCR2_RIE);
}

Inline void
hw_serial_handler_out()
{
    if (initflag[0] > 0)
        serial_handler_out(1);
    else
        *SCIF_SCSCR2 &= ~(SCSCR2_TIE);
}


/*
 *  ʸ
 */
Inline BOOL
hw_port_getready(HWPORT *p)
{
	return((*SCIF_SCFSR2 & SCFSR2_RDF)!=0);
}

/*
 *  ʸǤ뤫
 */
Inline BOOL
hw_port_putready(HWPORT *p)
{
    return((*SCIF_SCFSR2 & SCFSR2_TDFE) !=0);
}

/*
 *  ʸμФ
 */
Inline byte
hw_port_getchar(HWPORT *p)
{
    byte data;
    data = *SCIF_SCFRDR2;         
    *SCIF_SCFSR2 &= ~SCFSR2_RDF ; 
    return data;
}

/*
 *  ʸν񤭹
 */
Inline void
hw_port_putchar(HWPORT *p, byte c)
{
    *SCIF_SCFTDR2=c;
    *SCIF_SCFSR2 &= ~(SCFSR2_TDFE |SCFSR2_TEND);  
}

/*
 *  ؿ
 */
Inline void
hw_port_sendstart(HWPORT *p)
{
    if (!(p->sendflag)) {
        *SCIF_SCSCR2 |= SCSCR2_TIE;   /* ׵ */
        p->sendflag = 1;
    }
}

Inline void
hw_port_sendstop(HWPORT *p)
{
	if (p->sendflag) {
        *SCIF_SCSCR2 &= ~SCSCR2_TIE; /* ׵ػ */
        p->sendflag = 0;
	}
}

#endif /* _HW_SERIAL_H_ */





















