/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: hw_serial.h,v 1.4 2001/10/20 15:39:15 honda Exp $
 */


#ifndef _HW_SERIAL_H_
#define _HW_SERIAL_H_

/*
 *  åȰ¸ꥢI/O⥸塼MS7709ASE01ѡ
 *  ѡI/O(FDC37C935A)Υꥢ1
 */

#include "sh3.h"
#include "sys_config.h"
#include "cpu_config.h"
#include "ms7709ase01.h"

/*
 *  ꥢI/OγߥϥɥΥ٥ֹ
 */
#define INHNO_SERIAL	 UART_IRQ0


/*
 *  ꥢݡȤΥϡɥ¸
 *  Not yet! m68kΤ褦˥ȥ쥸¤Τˤ롣
 */
typedef struct hardware_serial_port_descripter {
    INT	  *initflag;	   /* ѥե饰ؤΥݥ   */
    BOOL  sendflag;        /* ߥ֥͡ե饰 */
} HWPORT;



/*
 * ߥ٥ϸǤ롥
 */
#define SCI1INTLVL   8


/*
 *  ܡ졼Ȥ
 *  19200bps
 */

#define BPS_SETTING 0x0006

/*
 *  ٥ݡȾ֥åν
 */

#define NUM_PORT	1	/* ݡȤ륷ꥢݡȤο */

static INT	initflag[1] = { 0 } ;	/* ѥե饰 */

#define HWPORT1	{ &initflag[0],  0 }


/*
 *  ꥢI/OݡȤν
 */
Inline BOOL
hw_port_initialize(HWPORT *p)
{
    HIOREG dummy;

    /* BIT7 = 1 */
    *SMSC_SCI0_LCR = 0x83 << 8;

    /* Set BPS */
    *SMSC_SCI0_DLL = ((BPS_SETTING & 0x00ff) << 8);   
    *SMSC_SCI0_DLM = ((BPS_SETTING >> 8) << 8);

    /* BIT7 = 0 Divisor Latch BIT6 = 0 No Break : BIT3 = 0 NoParity
       : BIT2 = 0 1Stopbit : BIT1,0 = {1.1} 8bitData */    
    *SMSC_SCI0_LCR = 0x03 << 8;

    /* Do not use FIFO */
    *SMSC_SCI0_FCR = 0x0000;

    /* Clear Status */
    dummy = *SMSC_SCI0_RBR;
    dummy = *SMSC_SCI0_LSR;
    
    
    
    /* Enable Receive Data Interrupt */
    *SMSC_SCI0_IER = (0x01 << 8);
    *SMSC_SCI0_MCR = 0x08 << 8;
    

    /*
     * ߴϢ
     * 顼ϥɥϿ٤
     */
    if (initflag[0] <= 0) {
        define_int_plevel(INHNO_SERIAL,SCI1INTLVL);
    }

    /*
     * MS7729RSE01ǤϡߤȯƤʤȳ
     * ٥16γߤȯƤޤưʤ
     */
    /* ׵ */
    *SMSC_SCI0_IER = (((*SMSC_SCI0_IER >> 8) | 0x02) << 8);   
    /* ׵ػ */        
    *SMSC_SCI0_IER = (((*SMSC_SCI0_IER >> 8) & ~0x02) << 8);   
    
    *(p->initflag) = 1;			/* ե饰 */
    return(FALSE);
}

/*
 *  ꥢI/OݡȤνλ
 */
Inline void
hw_port_terminate(HWPORT *p)
{
	*(p->initflag) = -1;		/* ե饰           */
    *SMSC_SCI0_IER   = 0x00;      /* ߤζػ               */
}

/*
 *  ꥢݡȳߥӥ롼ȡ
 */
extern void	serial_handler_in(int portid);
extern void	serial_handler_out(int portid);


/*
 *  ꥢI/OݡȤγߥϥɥ
 */
Inline void
hw_serial_handler()
{
    HIOREG dummy;
    
    if (initflag[0] > 0){
        serial_handler_in(1);
        serial_handler_out(1);
    }
    else
        dummy = *SMSC_SCI0_LSR;
}

/*
 *  ʸ
 */
Inline BOOL
hw_port_getready(HWPORT *p)
{
	return(((*SMSC_SCI0_LSR >> 8) & 0x01) != 0);
}

/*
 *  ʸǤ뤫
 */
Inline BOOL
hw_port_putready(HWPORT *p)
{
	return(((*SMSC_SCI0_LSR >> 8) & 0x60) != 0);
}

/*
 *  ʸμФ
 */
Inline byte
hw_port_getchar(HWPORT *p)
{
    return (*SMSC_SCI0_RBR >> 8);
}

/*
 *  ʸν񤭹
 */
Inline void
hw_port_putchar(HWPORT *p, byte c)
{
    *SMSC_SCI0_THR = c << 8;
}

/*
 *  ؿ
 */
Inline void
hw_port_sendstart(HWPORT *p)
{
    if (!(p->sendflag)) {
        /* ׵ */
        *SMSC_SCI0_IER = (((*SMSC_SCI0_IER >> 8) | 0x02) << 8);   
        p->sendflag = 1;
    }
}

Inline void
hw_port_sendstop(HWPORT *p)
{
	if (p->sendflag) {
        /* ׵ػ */        
        *SMSC_SCI0_IER = (((*SMSC_SCI0_IER >> 8) & ~0x02) << 8);   
        p->sendflag = 0;
	}
}

#endif /* _HW_SERIAL_H_ */





















