/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: sys_config.c,v 1.9 2001/11/09 08:35:55 honda Exp $
 */


#include "jsp_kernel.h"
#include "ms7709ase01.h"
#include "sh3.h"


/*
 *  SMSC Super I/O (FDC37C935A)ν
 */
void
smsc_init()
{
    /*
     * Enter Config mode 
     */
    *SMSC_CONFIG_PORT = 0x55 << 8;
    *SMSC_CONFIG_PORT = 0x55 << 8;


    /*
     * Init SCI0
     */
    /* Power on */
    smsc_config_write(0x22, (smsc_config_read(0x22) | 0x10));
    /* Select SCI0 */
    smsc_config_write(0x07, 0x04);
    /* Enable SCI0 */
    smsc_config_write(0x30, 0x01);
    /* Set SCI0 Base Address */
    smsc_config_write(0x60, (SMSC_SCI0_BASE_ADDR & 0xff00) >> 8);
    smsc_config_write(0x61, (SMSC_SCI0_BASE_ADDR & 0xff));    
    /* IRQ4 */
    smsc_config_write(0x70, 0x04);

    

    /*
     *  Exit Config mode
     */
    *SMSC_CONFIG_PORT = 0xAA << 8;
}



/*
 *  åȥƥ¸ 롼
 */
void
sys_initialize()
{
    /* Enable IRL Interrupt */
    *ICR1 = 0x5000;

    /* Init Super I/O */
    smsc_init();

#ifndef GDB_STUB
    SCIF.SCSCR2 = 0;  /* SCIF,PåȤ */
    SCIF.SCFCR2 = SCFCR2_TFRST | SCFCR2_RFRST; /* FIFO򥯥ꥢ */
    SCIF.SCSMR2 = 0;         /* Async,8data,1stop,no parity */
    SCIF.SCBRR2 = SCIF_BPS_VALUE; /* ܡ졼Ȥ */

    /*
     * ܡ졼Ȥ塢1ʬԤʤФʤʤ
     * ХơȥȥΥեå奫󥿤Ȥ
     * 1ʬԤ
     */
    *RFCR = RFCR_CLEAR;
    while( *RFCR < WAIT_RFCR_FOR_SCI);
    
    SCIF.SCFCR2 = 0x30;           /* R-FIFO=1,T-FIFO=1 ȥꥬ */
    SCIF.SCSSR2 = 0x0060;         /* 顼ե饰򥯥ꥢ */
    SCIF.SCSCR2 = 0x30;           /* Start TE = 1 RE = 1  */
#endif /* GDB_STUB */
}


/*
 *  åȥƥνλ롼
 *
 *  ƥλ˻Ȥ̾ϥ˥ƤӽФǼ¸롥
 *  
 */
void
sys_exit(void)
{
  Asm("trapa #0xff"::);
}

/*
 *   ƥʸλ
 */

#ifdef GDB_STUB
#define SYS_PUT_CHAR(c) stub_putc(c)
#elif defined(PARTNER_J)
#define SYS_PUT_CHAR(c) partner_putc(c)
#else  /* ¾ */
#define SYS_PUT_CHAR(c) scif_putc(c)
#endif 


void
sys_putc(char c)
{
    if (c == '\n') {
        SYS_PUT_CHAR('\r');
    }
    SYS_PUT_CHAR(c);
}

#ifdef PARTNER_J
char
partner_syscall(int callno, char put_char)
{
    char get_char = 0x00;
    Asm("mov %1, r0;
         mov %2, r2;
         .global _sysc_et;
         _sysc_et:;
         nop;
         mov r0,%0"
        : "=r"(get_char)
        : "r"(callno),"r"(put_char)
        : "r0","r2");
    return get_char;
}

void
partner_putc(char c)
{
    partner_syscall(PARTNER_OUT,c);
}
#endif /* PARTNER_J */


