/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: hw_serial.h,v 1.2 2001/11/15 13:18:32 takayuki Exp $
 */

/*
 *	åȰ¸ꥢI/O⥸塼V850E/MA1 ¢Ʊꥢѡ
 */

#ifndef _HW_SERIAL_H_
#define _HW_SERIAL_H_

#include "sys_config.h"

/*
 *  ꥢݡȤΥϡɥ¸
 */

#define FLG_RECEIVED 1

typedef struct hardware_serial_port_descripter {
} HWPORT;
#define HWPORT1 {}

static unsigned int _serial_flag = 0;

/*
 *  ꥢI/OγߥϥɥΥ٥ֹ
 */
#define INHNO_SERIAL_IN		(0x2e + (SERIAL_PORT * 4))
#define INHNO_SERIAL_OUT	(0x2f + (SERIAL_PORT * 4))

/*
 *  ٥ݡȾ֥åν
 */

#define NUM_PORT	1	/* ݡȤ륷ꥢݡȤο */

/*
 *  ꥢI/OݡȤν
 */
Inline BOOL
hw_port_initialize(HWPORT *p)
{
	if( (*(volatile unsigned char *) ASIM(SERIAL_PORT) & 0x80) == 0 )
	{
	    	/* Ʊꥢ̿ϩν */

			/* ݡȤ򳫤 */
		*(volatile unsigned char *) PFC4 = 0x1b;
		*(volatile unsigned char *) PMC4 = 7 << (3*SERIAL_PORT);

			/* ܡ졼ȯν */
		*(volatile unsigned char *) CKSR(SERIAL_PORT)  = SERIAL_CLKDIV;
		*(volatile unsigned char *) BRGC(SERIAL_PORT)  = SERIAL_COMPAREVALUE;
		*(volatile unsigned char *) ASIM(SERIAL_PORT) |= 0x80;	//enable ASIO

		__asm("nop; nop");

		*(volatile unsigned char *) ASIM(SERIAL_PORT) |= 0x04;	//8bit length

		__asm("nop; nop");

		*(volatile unsigned char *) ASIM(SERIAL_PORT) |= 0x60;	//Tx, Rx on

			/*  */
		*(volatile unsigned char *)SRIC(SERIAL_PORT) = 0 | SERIAL_INT_PRIORITY;
		*(volatile unsigned char *)STIC(SERIAL_PORT) = 0 | SERIAL_INT_PRIORITY;
	}
	return(FALSE);
}

/*
 *  ꥢI/OݡȤνλ
 */
Inline void
hw_port_terminate(HWPORT *p)
{
}

/*
 *  ꥢݡȳߥӥ롼ȡ
 */
extern void	serial_handler_in(int portid);
extern void	serial_handler_out(int portid);

/*
 *  ʸ
 */
Inline BOOL
hw_port_getready(HWPORT *p)
{
	return (_serial_flag & FLG_RECEIVED) != 0 ? TRUE : FALSE;
}

/*
 *  ʸǤ뤫
 */
Inline BOOL
hw_port_putready(HWPORT *p)
{
	return (*(volatile char *)ASIF(SERIAL_PORT) & 0x2) != 0 ? FALSE : TRUE;
}

/*
 *  ʸμФ
 */
Inline unsigned char
hw_port_getchar(HWPORT *p)
{
	_serial_flag &= FLG_RECEIVED;
	*(volatile unsigned char *) SRIC(SERIAL_PORT) &= 0x7f;
	return *(volatile unsigned char *)RXB(SERIAL_PORT);
}

/*
 *  ʸν񤭹
 */
Inline void
hw_port_putchar(HWPORT *p, unsigned char c)
{
	*(volatile unsigned char *) TXB(SERIAL_PORT) = c;
}

/*
 *  ؿ
 */
Inline void
hw_port_sendstart(HWPORT *p)
{
}

Inline void
hw_port_sendstop(HWPORT *p)
{
}

Inline void
hw_serial_handler_in(void)
{
	_serial_flag |= FLG_RECEIVED;
    serial_handler_in(CONSOLE_PORTID);
}

Inline void
hw_serial_handler_out(void)
{
	serial_handler_out(CONSOLE_PORTID);
}

#endif /* _HW_SERIAL_H_ */
