/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: cpu_defs.h,v 1.3 2001/11/12 14:55:23 takayuki Exp $
 */


/*
 *	ץå˰¸Windowsѡ
 */

#ifndef _CPU_DEFS_H_
#define _CPU_DEFS_H_

#define WINDOWS

#include "itron.h"
#include "vwindows.h"

#define INT_NUMINTERRUPTS	7	/* ܿ */

#ifndef _MACRO_ONLY

typedef	UINT		INHNO;		/* ߥϥɥֹ */
typedef	UINT		EXCNO;		/* CPU㳰ϥɥֹ */

/*
 * ߥߥ졼Ϣ
 */

#define INT_STAT_PENDING 0x01
#define INT_STAT_RUNNING 0x02
#define INT_STAT_ENABLED 0x04

struct tagInterruptLevel
{
	HANDLE	ThreadHandle;
	DWORD	ThreadID;
	void *	Routine;
	unsigned char Status;
};

extern struct tagInterruptLevel InterruptLevel[INT_NUMINTERRUPTS];
extern CRITICAL_SECTION InterruptCriticalSection;
extern unsigned int CurrentInterruptLevel;


#define EXC_MAXITEMS 32

struct tagExceptionLevel
{
	DWORD ExceptionCode;
	void * Routine;
};

extern struct tagExceptionLevel ExceptionLevel[EXC_MAXITEMS];

/*
 * ߥߥ졼ؿ
 */

extern BOOL def_int( unsigned int ims, void * rtn);	/* ϥɥ */
extern BOOL		ini_int( void );				/*  */
extern void		fin_int( void );
extern BOOL		ras_int(unsigned int ims);		/* ׵ */
extern unsigned int sns_int( void );			/* Sense the highest pending request */
extern HANDLE	sch_int( void );				/* ߤΥ塼 */

 /* Ĥȶػߤϰ˴طʤ&ػߤȤʤ */
extern ER	ena_int(unsigned int ims);			/*  */
extern ER	dis_int(unsigned int ims);			/* ػ */

extern ER	chg_ims(unsigned int ims);			/* ߥ٥ */
extern ER	get_ims(unsigned int *p_ims);		/* ߥ٥μ */

extern BOOL def_exc( DWORD exc, void * routine);
extern BOOL ini_exc(void);
extern void fin_exc(void);

#endif /* _MACRO_ONLY */

#include "hw_timer.h"

/*
 *  ƥå
 */
#define	TIC_NUME	TIMER_CLOCK_WINDOWS		/* ƥåμʬ */
#define	TIC_DENO	1		/* ƥåμʬ */


/*
 * ĥޡ (Pentium Timer)
 */

typedef UD SYSUTIM;

Inline ER
vxget_tim(SYSUTIM * pk_sysutim)
{
	QueryPerformanceCounter((LARGE_INTEGER *)pk_sysutim);
	return E_OK;
}

#endif /* _CPU_DEFS_H_ */
