/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: syslog.h,v 1.5 2001/10/08 01:46:03 hiro Exp $
 */

/*
 *	ƥǽ
 *
 *  ƥӥϡƥΥϤ뤿Υӥ
 *  Ǥ롥ͥ뤫ΥνϤˤѤ뤿ᡤԤ
 *  ˤϤ뤳ȤϤʤ
 *  ϡͥΥХåե˽񤭹फ٥ʸ
 *  ϴؿѤƽϤ롥ɤȤϡĥӥڤ
 *  뤳ȤǤ롥
 *  Хåեΰ褬ХեˤϡŤäƾ
 *  񤭤롥
 */

#ifndef _SYSLOG_H_
#define _SYSLOG_H_

#include <itron.h>

/*
 *  Υǡ¤
 */

#define TMAX_LOGINFO	6

typedef struct {
		UINT	logtype;		/* μ */
		SYSTIM	logtim;			/*  */
		VP_INT	loginfo[TMAX_LOGINFO];	/* ¾Υ */
	} SYSLOG;

/*
 *  ν٤
 */
#define LOG_EMERG	0		/* åȥͤ륨顼 */
#define LOG_ALERT	1
#define LOG_CRIT	2
#define LOG_ERR		3		/* ƥ२顼 */
#define LOG_WARNING	4		/* ٹå */
#define LOG_NOTICE	5
#define LOG_INFO	6
#define LOG_DEBUG	7		/* ǥХåѥå */

/*
 *  ν٤Υӥåȥޥåפ뤿Υޥ
 */
#define LOG_MASK(prio)	(1 << (prio))
#define LOG_UPTO(prio)	((1 << ((prio) + 1)) - 1)

/*
 *  μ̤
 */
#define LOG_TYP_INTERRUPT	0x01	/* ߥϥɥ */
#define LOG_TYP_ISR		0x02	/* ߥӥϥɥ */
#define LOG_TYP_TIMERHDR	0x03	/* ।٥ȥϥɥ */
#define LOG_TYP_CPUEXC		0x04	/* CPU㳰ϥɥ */
#define LOG_TYP_TSKEXC		0x05	/* 㳰롼 */
#define LOG_TYP_TSKSTAT		0x06	/* Ѳ */
#define LOG_TYP_DISPATCH	0x07	/* ǥѥå */
#define LOG_TYP_SVC		0x08	/* ӥ */
#define LOG_TYP_COMMENT		0x09	/* ȡʸΤߤΥ */
#define LOG_ENTER		0x00	/*  */
#define LOG_LEAVE		0x80	/* иλ */

/*
 *  ν
 */
extern ER	syslog_write(UINT prio, SYSLOG *p_syslog);

/*
 *  ХåեΥɽФ
 */
extern ER_UINT	syslog_read(SYSLOG *p_syslog);

/* 
 *  Ϥ٤ν٤
 */
extern ER	syslog_setmask(UINT logmask, UINT lowmask);

/*
 *  Ϥ뤿Υޥ
 *
 *  format Ӹ³ΰå򡤽 prio 
 *  ȤƽϤ뤿Υޥarg1argn  VP_INT˥
 *  Ȥ뤿ᡤVP_INT˷ѴǤǤդηǤ褤
 */

#define	syslog_0(prio, format)	_syslog_0(prio, format)

#define	syslog_1(prio, format, arg1) \
		_syslog_1(prio, format, (VP_INT)(arg1))

#define	syslog_2(prio, format, arg1, arg2) \
		_syslog_2(prio, format, (VP_INT)(arg1), (VP_INT)(arg2))

#define	syslog_3(prio, format, arg1, arg2, arg3) \
		_syslog_3(prio, format, (VP_INT)(arg1), (VP_INT)(arg2),	\
						(VP_INT)(arg3))

#define	syslog_4(prio, format, arg1, arg2, arg3, arg4) \
		_syslog_4(prio, format, (VP_INT)(arg1), (VP_INT)(arg2),	\
				(VP_INT)(arg3), (VP_INT)(arg4))

#define	syslog_5(prio, format, arg1, arg2, arg3, arg4, arg5) \
		_syslog_5(prio, format, (VP_INT)(arg1), (VP_INT)(arg2),	\
			(VP_INT)(arg3), (VP_INT)(arg4), (VP_INT)(arg5))

/*
 *  Ϥ뤿Υ饤֥ؿ
 */

Inline ER
_syslog_0(UINT prio, const char *format)
{
	SYSLOG	syslog;

	syslog.logtype = LOG_TYP_COMMENT;
	syslog.loginfo[0] = (VP_INT) format;
	return(syslog_write(prio, &syslog));
}

Inline ER
_syslog_1(UINT prio, const char *format, VP_INT arg1)
{
	SYSLOG	syslog;

	syslog.logtype = LOG_TYP_COMMENT;
	syslog.loginfo[0] = (VP_INT) format;
	syslog.loginfo[1] = arg1;
	return(syslog_write(prio, &syslog));
}

Inline ER
_syslog_2(UINT prio, const char *format, VP_INT arg1, VP_INT arg2)
{
	SYSLOG	syslog;

	syslog.logtype = LOG_TYP_COMMENT;
	syslog.loginfo[0] = (VP_INT) format;
	syslog.loginfo[1] = arg1;
	syslog.loginfo[2] = arg2;
	return(syslog_write(prio, &syslog));
}

Inline ER
_syslog_3(UINT prio, const char *format, VP_INT arg1,
				VP_INT arg2, VP_INT arg3)
{
	SYSLOG	syslog;

	syslog.logtype = LOG_TYP_COMMENT;
	syslog.loginfo[0] = (VP_INT) format;
	syslog.loginfo[1] = arg1;
	syslog.loginfo[2] = arg2;
	syslog.loginfo[3] = arg3;
	return(syslog_write(prio, &syslog));
}

Inline ER
_syslog_4(UINT prio, const char *format, VP_INT arg1, VP_INT arg2,
				VP_INT arg3, VP_INT arg4)
{
	SYSLOG	syslog;

	syslog.logtype = LOG_TYP_COMMENT;
	syslog.loginfo[0] = (VP_INT) format;
	syslog.loginfo[1] = arg1;
	syslog.loginfo[2] = arg2;
	syslog.loginfo[3] = arg3;
	syslog.loginfo[4] = arg4;
	return(syslog_write(prio, &syslog));
}

Inline ER
_syslog_5(UINT prio, const char *format, VP_INT arg1, VP_INT arg2,
				VP_INT arg3, VP_INT arg4, VP_INT arg5)
{
	SYSLOG	syslog;

	syslog.logtype = LOG_TYP_COMMENT;
	syslog.loginfo[0] = (VP_INT) format;
	syslog.loginfo[1] = arg1;
	syslog.loginfo[2] = arg2;
	syslog.loginfo[3] = arg3;
	syslog.loginfo[4] = arg4;
	syslog.loginfo[5] = arg5;
	return(syslog_write(prio, &syslog));
}

/*
 *  Ϥ뤿Υ饤֥ؿʲѿǡ
 */
extern ER	syslog(UINT prio, const char *format, ...);

/* 
 *  ΥեޥåȽ
 */
extern void	syslog_printf(SYSLOG *p_syslog, void (*putc)(char));

#endif /* _SYSLOG_H_ */
