/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: cyclic.c,v 1.5 2001/09/13 15:20:43 hiro Exp $
 */

/*
 *	ϥɥ鵡ǽ
 */

#include "jsp_kernel.h"
#include "check.h"
#include "cyclic.h"

/*
 *  ϥɥIDκ͡kernel_cfg.c
 */
extern const ID	tmax_cycid;

/*
 *  ϥɥ֥åΥꥢkernel_cfg.c
 */
extern const CYCINIB	cycinib_table[];

/*
 *  ϥɥ֥åΥꥢkernel_cfg.c
 */
extern CYCCB	cyccb_table[];

/*
 *  ϥɥIDϥɥ֥åФΥޥ
 */
#define INDEX_CYC(cycid)	((cycid) - TMIN_CYCID)
#define get_cyccb(cycid)	(&(cyccb_table[INDEX_CYC(cycid)]))

/*
 *  ϥɥ鵯ư롼 (ȤΤ)
 */
static void	call_cychdr(CYCCB *cyccb);

/*
 *  ϥɥ鵯ưΤΥ।٥ȥ֥åϿ
 */
static void
tmevtb_enqueue_cyc(CYCCB *cyccb, EVTTIM evttim)
{
	tmevtb_enqueue_evttim(&(cyccb->tmevtb), evttim,
				(CBACK) call_cychdr, (VP) cyccb);
	cyccb->evttim = evttim;
}

/*
 *  ϥɥ鵡ǽν
 */
void
cyclic_initialize()
{
	INT	i;
	CYCCB	*cyccb;

	for (cyccb = cyccb_table, i = 0; i < tmax_cycid; cyccb++, i++) {
		cyccb->cycinib = &(cycinib_table[i]);
		if ((cyccb->cycinib->cycatr & TA_STA) != 0) {
			cyccb->cycsta = TRUE;
			tmevtb_enqueue_cyc(cyccb, cyccb->cycinib->cycphs);
		}
		else {
			cyccb->cycsta = FALSE;
		}
	}
}

/*
 *  ϥɥư
 */
SYSCALL ER
sta_cyc(ID cycid)
{
	CYCCB	*cyccb;

	CHECK_TSKCTX_UNL();
	CHECK_CYCID(cycid);
	cyccb = get_cyccb(cycid);

	t_lock_cpu();
	if (cyccb->cycsta) {
		tmevtb_dequeue(&(cyccb->tmevtb));
	}
	else {
		cyccb->cycsta = TRUE;
	}
	tmevtb_enqueue_cyc(cyccb, base_time + cyccb->cycinib->cyctim);
	t_unlock_cpu();
	return(E_OK);
}

/*
 *  ϥɥư
 */
SYSCALL ER
stp_cyc(ID cycid)
{
	CYCCB	*cyccb;

	CHECK_TSKCTX_UNL();
	CHECK_CYCID(cycid);
	cyccb = get_cyccb(cycid);

	t_lock_cpu();
	if (cyccb->cycsta) {
		cyccb->cycsta = FALSE;
		tmevtb_dequeue(&(cyccb->tmevtb));
	}
	t_unlock_cpu();
	return(E_OK);
}

/*
 *  ϥɥ鵯ư롼
 */
static void
call_cychdr(CYCCB *cyccb)
{
	/*
	 *  εưΤΥ।٥ȥ֥åϿ롥
	 *
	 *  ƱƥåǼϥɥٵư٤ˤϡ
	 *  δؿ isig_tim äˡ٤δؿƤФ
	 *  Ȥˤʤ롥
	 */
	tmevtb_enqueue_cyc(cyccb, cyccb->evttim + cyccb->cycinib->cyctim);

	/*
	 *  ϥɥCPUå֤ǸƤӽФ
	 */
	i_unlock_cpu();
	(*cyccb->cycinib->cychdr)(cyccb->cycinib->exinf);
	i_lock_cpu();
}
