/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  ξΤ줫˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: syslog.c,v 1.4 2001/10/08 01:46:06 hiro Exp $
 */

/*
 *  ƥǽ
 */

#include "jsp_kernel.h"
#include "time_event.h"

/*
 *  ХåեȤ˥뤿Υݥ
 */

#define TCNT_SYSLOG_BUFFER	32

static SYSLOG	syslog_buffer[TCNT_SYSLOG_BUFFER];
static UINT	syslog_count;
static UINT	syslog_head;
static UINT	syslog_tail;
static UINT	syslog_lost;

/*
 *  Ϥ٤ν١ʥӥåȥޥåס
 */
static UINT	syslog_logmask;		/* ϿϤ٤ */
static UINT	syslog_lowmask;		/* ٥Ϥ٤ */

/*
 *  ƥȤ˰ͤʤCPUåå
 */
#define	lock_cpu()	(sense_context() ? i_lock_cpu() : t_lock_cpu())
#define	unlock_cpu()	(sense_context() ? i_unlock_cpu() : t_unlock_cpu())

/*
 *  ƥǽν
 */
void
syslog_initialize()
{
	syslog_count = 0;
	syslog_head = syslog_tail = 0;
	syslog_lost = 0;

	syslog_logmask = LOG_UPTO(LOG_NOTICE);
	syslog_lowmask = LOG_UPTO(LOG_NOTICE);
}     

/* 
 *  ν
 */
ER
syslog_write(UINT prio, SYSLOG *p_syslog)
{
	BOOL	locked;

	p_syslog->logtim = systim_offset + current_time;
	if ((syslog_logmask & LOG_MASK(prio)) != 0) {
		/*
		 *  CPUå֤¹ԥƥȤˤ餺ưǤ
		 *  褦ˤ롥
		 */
		locked = sense_lock();
		if (!locked) {
			lock_cpu();
		}
		if ((syslog_lowmask & LOG_MASK(prio)) != 0) {
			/*
			 *  ٥ϤؤνФ
			 */
			syslog_printf(p_syslog, sys_putc);
			sys_putc('\n');
		}
		else {
			/*
			 *  Хåեؤν
			 */
			syslog_buffer[syslog_tail] = *p_syslog;
			syslog_tail++;
			if (syslog_tail >= TCNT_SYSLOG_BUFFER) {
				syslog_tail = 0;
			}
			if (syslog_count < TCNT_SYSLOG_BUFFER) {
				syslog_count++;
			}
			else {
				syslog_head = syslog_tail;
				syslog_lost++;
			}
		}
		if (!locked) {
			unlock_cpu();
		}
	}
	return(E_OK);
}

/*
 *  ХåեɽФ
 */
ER_UINT
syslog_read(SYSLOG *p_syslog)
{
	BOOL	locked;
	INT	n;

	/*
	 *  CPUå֤¹ԥƥȤˤ餺ưǤ褦ˤ
	 *  롥
	 */
	locked = sense_lock();
	if (!locked) {
		lock_cpu();
	}
	if (syslog_count > 0) {
		*p_syslog = syslog_buffer[syslog_head];
		syslog_count--;
		syslog_head++;
		if (syslog_head >= TCNT_SYSLOG_BUFFER) {
			syslog_head = 0;
		}
		n = syslog_lost;
		syslog_lost = 0;
	}
	else {
		n = E_OBJ;
	}
	if (!locked) {
		unlock_cpu();
	}
	return(n);
}

/* 
 *  Ϥ٤ν٤
 */
ER
syslog_setmask(UINT logmask, UINT lowmask)
{
	syslog_logmask = logmask;
	syslog_lowmask = lowmask;
	return(E_OK);
}

/* 
 *  ƥǽνλ
 *
 *  Хåե˵Ͽ줿٥ϵǽѤƽϤ
 *  롥
 */
void
syslog_terminate()
{
	SYSLOG	syslog, lostlog;
	char	*bufmsg = "-- buffered messages --";
	char	*lostmsg = "%d messages are lost.";
	INT	n;

	lostlog.loginfo[0] = (VP_INT) bufmsg;
	syslog_printf(&lostlog, sys_putc);
	sys_putc('\n');
	while ((n = syslog_read(&syslog)) >= 0) {
		if (n > 0) {
			lostlog.loginfo[0] = (VP_INT) lostmsg;
			lostlog.loginfo[1] = (VP_INT) n;
			syslog_printf(&lostlog, sys_putc);
			sys_putc('\n');
		}
		syslog_printf(&syslog, sys_putc);
		sys_putc('\n');
	}
	sys_putc('\n');
}

/*
 *  ͤʸѴ
 */
static void
convert(unsigned int val, int radix, const char *radchar, int width,
		int minus, int padzero, void (*putc)(char))
{
	char	buf[12];
	int	i, j;

	i = 0;
	do {
		buf[i++] = radchar[val % radix];
		val /= radix;
	} while (val != 0);

	width -= minus;
	if (minus > 0 && padzero > 0) {
		(*putc)('-');
	}
	for (j = i; j < width; j++) {
		(*putc)((char)(padzero > 0 ? '0' : ' '));
	}
	if (minus > 0 && padzero <= 0) {
		(*putc)('-');
	}
	while (i > 0) {
		(*putc)(buf[--i]);
	}
}

/*
 *  եޥåѥ饤֥ؿ
 */
static char const raddec[] = "0123456789";
static char const radhex[] = "0123456789abcdef";
static char const radHEX[] = "0123456789ABCDEF";

void
syslog_printf(SYSLOG *p_syslog, void (*putc)(char))
{
	char	*format;
	int	argno;
	int	c;
	int	width;
	int	padzero;
	int	val;
	char	*str;

	format = (char *)(p_syslog->loginfo[0]);
	argno = 1;

	while ((c = *format++) != '\0') {
		if (c != '%') {
			(*putc)((char) c);
			continue;
		}

		width = padzero = 0;
		if ((c = *format++) == '0') {
			padzero = 1;
			c = *format++;
		}
		while ('0' <= c && c <= '9') {
			width = width*10 + c - '0';
			c = *format++;
		}
		switch (c) {
		case 'd':
			val = (int)(p_syslog->loginfo[argno++]);
			if (val >= 0) {
				convert(val, 10, raddec, width,
						0, padzero, putc);
			}
			else {
				convert(-val, 10, raddec, width,
						1, padzero, putc);
			}
			break;
		case 'u':
			val = (int)(p_syslog->loginfo[argno++]);
			convert(val, 10, raddec, width, 0, padzero, putc);
			break;
		case 'x':
			val = (int)(p_syslog->loginfo[argno++]);
			convert(val, 16, radhex, width, 0, padzero, putc);
			break;
		case 'X':
			val = (int)(p_syslog->loginfo[argno++]);
			convert(val, 16, radHEX, width, 0, padzero, putc);
			break;
		case 'c':
			(*putc)((char)(int)(p_syslog->loginfo[argno++]));
			break;
		case 's':
			str = (char *)(p_syslog->loginfo[argno++]);
			while ((c = *str++) != '\0') {
				(*putc)((char) c);
			}
			break;
		case '%':
			(*putc)('%');
			break;
		case '\0':
			format--;
			break;
		default:
			break;
		}
	}
}
