/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: kernel.cpp,v 1.2 2001/02/23 09:46:47 takayuki Exp $
 */

#include "stdafx.h"
#include "devicemanager.h"
#include "kernel.h"

/////////////////////////////////////////////////////////////////////////////
// CKernel

CKernel::CKernel()
{
	Valid = _Module.AttachKernel(this);
}

CKernel::~CKernel()
{
	_Module.DetachKernel(this);
}

STDMETHODIMP CKernel::IsValid(BOOL *valid)
{
	*valid = Valid ? TRUE : FALSE;
	return S_OK;
}

STDMETHODIMP CKernel::Read(unsigned long address, unsigned long sz, unsigned char data[])
{
	if(Valid && _Module.Read(this,address,sz,data))
		return S_OK;
	return E_FAIL;
}

STDMETHODIMP CKernel::Write(unsigned long address, unsigned long sz, unsigned char data[])
{
	if(Valid!=FALSE && _Module.Write(this,address,sz,data))
		return S_OK;
	return E_FAIL;
}
